﻿/*
 * Game Lib version 1.12 (Sep 9, 2019)
 */

var token
var pair = "[我],[姓名已隐藏]";

var role = '';
var reconnectCount = 0;
var matchidx = 0;
var screenWidth = 100;
var screenHeight = 100;
var commentIdx;

var HEARTBEAT_INTERVAL = 5000;
var HEARTBEAT_TIMEOUT1 = 3000;
var HEARTBEAT_TIMEOUT2 = 10000;
var HEARTBEAT_HEAD = 6000;
var lastBeatTime;

var quitSent = false;
var badNet = false;
var keepBadNet = false;
var gameover = false;
var inQuit = false;

var countdownClock = 0;
var timerCountdownClock;
var timer1, timer2, timer3, timer4, timer5, timer6;

var CommentProcessed = false;

//var commonQuitReasons = ["网络不佳，玩起来太累","界面显示异常，无法继续玩","猪队友，不想和TA玩了","没搞懂应该怎么玩","有事情了，只能退出","没意思，不想玩了","其他原因，不想说" ];
var allReasons = ["听不清", "显示异常", "太难了，始终无法完成", "不知道怎么进行下去", "有事离开", "其它"];

var simAnswers = '{ "info": [{"idx": -1, "comment": "表达清晰，有感染力"},\
{"idx": -2, "comment": "能听明白，但不够清晰"},\
{"idx": -3, "comment": "需要询问才能了解"},\
{"idx": -4, "comment": "表达不错，但口齿不清"},\
{"idx": -5, "comment": "大部分是错的"} ] }';
var simAnswersMsg;

//only for testing
document.onkeydown = function (event) {
    var e = event || window.event || arguments.callee.caller.arguments[0];
    if (e && e.keyCode == 27) { // ESC 

        if (nextGame == 2) {
            alert("比赛还未结束，现在退出将无法获得成绩。确认要退出？");
        } else if (nextGame == 3) {
            alert("直接退出");
        } else {
            if (badNet) {
                //				onQuit(0);
                alert("exit");
            } else {
                onQuit(-1);
            }
        }
    }
}

function requestServer(game, request, parameter) {
    var url = base + game + "/" + request + "?token=" + token;
    if (parameter != null) {
        url = url + "&" + parameter;
    }

    JavaScriptInterface.nativeSendMsg(encodeURI(url), '');

    //	if(debug){
    //		document.getElementById('debug').innerHTML = 'url: ' + url;
    //	}
}

function sendPeerMsg(type, msg) {
    if (msg == undefined || msg == null) {
        var msg = new Object();
    }
    msg.type = type;
    msg.matchid = matchidx;
    var jMsg = JSON.stringify(msg);
    JavaScriptInterface.nativeSendMsg('peer', jMsg);
    if (type == 'finish') {
        requestServer("GameLog", "Add", "logtype=Debug&details=finish_detail" + jMsg);
    }
}

//waiting for initialization of the native-JS interface, to guarantee the successful getToken
function onGameLoad() {
    timer1 = setTimeout(initStepOne, 1000);
}

function initStepOne() {

    //	document.getElementById('debug').innerHTML = 'step 1';

    var sUserAgent = navigator.userAgent.toLowerCase();
    var isIOS = (sUserAgent.match("ipad") == "ipad") || (sUserAgent.match("iphone") == "iphone");

    //	document.getElementById('debug').innerHTML = '<br />step 2' + isIOS;

    if (isIOS) {
        JavaScriptInterface = new Object();
        JavaScriptInterface.nativeCommand = function (cmd, param) {
            window.webkit.messageHandlers.nativeCommand.postMessage({ "cmd": cmd, "param": param });
        }
        JavaScriptInterface.nativeSendMsg = function (dest, msg) {
            window.webkit.messageHandlers.nativeSendMsg.postMessage({ "dest": dest, "msg": msg });
        }
    }

    if (isSimulation) {
        //simulate the native object
        JavaScriptInterface = new Object();
        JavaScriptInterface.nativeSendMsg = function (dest, msg) {
            //			document.getElementById('debug').innerHTML = 'dest: ' + dest + '<br />msg: ' + msg;
        };
        JavaScriptInterface.nativeCommand = function (cmd, param) {
            //			document.getElementById('debug').innerHTML = 'cmd: ' + cmd + '<br />param: ' + param;
        };
    }

    if (debug) {
        document.getElementById('debug').style.visibility = "visible";
        document.getElementById('comment-page').style.height = "85%";
        document.getElementById('comment-page').style.bottom = "15%";
    }

    /*	JavaScriptInterface.nativeCommand('getPair', '');
        if(isSimulation){
            pair = 'Trump,Wang';
        }
    */
    JavaScriptInterface.nativeCommand('getToken', '');
    if (isSimulation) {
        token = '000000';
        initStepTwo();
    }

    //get role from url parameters
    if (isSimulation) {
        role = window.location.search;
        if (role == "?teller") {
            onNativeMsg('server', tellerInitString);
        } else if (role == "?listener") {
            onNativeMsg('server', listenerInitString);
        }
    }

    initGame();
}

//callback by APP when token is given
function initStepTwo() {

    if (token == null || token == undefined) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"未能获取token(810)\",\"t\":\"6\"}');
        requestServer("Game", "Quit", "reason=NET:no_token&matchidx=" + matchidx);
        quitSent = true;
        timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
    }

    simAnswersMsg = eval("(" + simAnswers + ")");

    screenWidth = document.body.clientWidth;
    screenHeight = document.body.clientHeight;

    requestServer("GameLog", "Add", "logtype=GetInitInfo&details=request");

    requestServer(apiCode, "GetInitInfo");
}

function startCountdownClock(timelimit) {
    countdownClock = timelimit;
    timerCountdownClock = setInterval(updateCountdownClock, 1000);
    document.getElementById("countdownClock").innerHTML = "剩余时间：" + countdownClock + " 秒";
}

function updateCountdownClock() {
    var clockNumber;
    if (countdownClock > 0) {
        countdownClock--;
        if (countdownClock < 10) {
            clockNumber = '<span class="red_text">' + countdownClock + '</span>';
        } else if (countdownClock < 20) {
            clockNumber = '<span class="orange_text">' + countdownClock + '</span>';
        } else {
            clockNumber = countdownClock;
        }

        document.getElementById("countdownClock").innerHTML = "剩余时间：" + clockNumber + " 秒";
    } else if (countdownClock == 0) {
        clearInterval(timerCountdownClock);
        onGameTimeout();
    }
}

function initButton(id, foreColor, backColor) {
    document.getElementById(id).style.visibility = "visible";
    document.getElementById(id).addEventListener("touchstart", onTouchButton, true);
    document.getElementById(id).addEventListener("touchend", onLeaveButton, true);
    /*	document.getElementById(id).btnTextColor = window.getComputedStyle(document.getElementById(id)).color;
        if(pressedTextColor != null){
            document.getElementById(id).pressedTextColor = pressedTextColor;
        } else {
            document.getElementById(id).pressedTextColor = document.getElementById(id).btnTextColor;
        }*/
    document.getElementById(id).foreColor = window.getComputedStyle(document.getElementById(id)).color;
    document.getElementById(id).backColor = window.getComputedStyle(document.getElementById(id)).backgroundColor;
    if (foreColor != null && foreColor != undefined) {
        document.getElementById(id).foreColor = foreColor;
        document.getElementById(id).style.color = foreColor;
    }
    if (backColor != null && backColor != undefined) {
        document.getElementById(id).backColor = backColor;
        document.getElementById(id).style.backgroundColor = backColor;
    }
}

function disableButton(btn) {
    btn.disabled = true;
    btn.style.color = 'lightgray';
    btn.style.borderColor = 'lightgray';
    btn.style.backgroundColor = 'gray';
    btn.removeEventListener("touchstart", onTouchButton, true);
    btn.removeEventListener("touchend", onLeaveButton, true);
}

function onTouchButton(e) {
    if (!e.target.selected) {
        /*		e.target.style.backgroundColor = window.getComputedStyle(e.target).borderColor;
                e.target.style.color = e.target.pressedTextColor;*/
        e.target.style.backgroundColor = e.target.foreColor;
        e.target.style.color = e.target.backColor;
    }
}

function onLeaveButton(e) {
    if (!e.target.selected) {
        /*		e.target.style.backgroundColor = "transparent";
                e.target.style.color = e.target.btnTextColor;*/
        e.target.style.backgroundColor = e.target.backColor;
        e.target.style.color = e.target.foreColor;
    }
}

function startHeartbeat() {
    timer5 = setInterval(onHeartBeat, HEARTBEAT_INTERVAL);
    lastBeatTime = currentTime + HEARTBEAT_HEAD;

    if (isSimulation) {
        setTimeout(simHeartbeat, HEARTBEAT_HEAD + 2 * HEARTBEAT_INTERVAL);
    }
}
function simHeartbeat() {
    onNativeMsg('peer', '{"type":"heartbeat", "matchid":0}');
}

function onHeartBeat() {

    var beatTime = new Date();
    /*	if(beatTime.getTime() > (lastBeatTime + HEARTBEAT_INTERVAL + HEARTBEAT_TIMEOUT2) ){
            clearInterval(timer5);
            if(!quitSent){
                JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"对方手机无响应(805)\",\"t\":\"6\"}');
                requestServer("Game", "Quit", "reason=NET:no_heartbeat&matchidx="+matchidx);
                quitSent = true;
            }
            timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
            if(isSimulation){
                alert("heartbeat failed!");
            }
        } else if(beatTime.getTime() > (lastBeatTime + HEARTBEAT_INTERVAL + HEARTBEAT_TIMEOUT1) ){*/
    if (beatTime.getTime() > (lastBeatTime + HEARTBEAT_INTERVAL + HEARTBEAT_TIMEOUT1)) {
        requestServer("Game", "Notification", "type=heartbeatTimeout&matchidx=" + matchidx);
        displayBadnet();
    } else {
        if (!keepBadNet) {
            //wait when exit confirmation dialogbox is popped up
            hideBadnet();
        }
    }

    sendPeerMsg('heartbeat');
}

function displayBadnet() {
    //Note: set animation play state to "running" when start, and set animation play state to "paused"
    //when end (in the hideBadSound below) to avoid short flash at beginning. Set timer to less than interval to hide
    //the text before next visible cycle to avoid short flash at last.
    if (document.getElementById(mainPage).style.visibility == "hidden") {
        return;
    }

    document.getElementById("badnetAlert").style.visibility = "visible";
    document.getElementById("badnetAlert").style.animationPlayState = "running";
    //	clearTimeout(timer6);
    //	timer6 = setTimeout(hideBadnet, HEARTBEAT_INTERVAL - 200);
    badNet = true;
}

function hideBadnet() {
    document.getElementById("badnetAlert").style.animationPlayState = "paused";
    document.getElementById("badnetAlert").style.visibility = "hidden";
    badNet = false;
}

function onBadSound() {
    sendPeerMsg('badsound');
}

function displayBadSound() {
    //Note: set animation play state to "running" when start, and set animation play state to "paused"
    //when end (in the hideBadSound below) to avoid short flash at begining. Set timer to 4900ms to hide
    //the text before next visible cycle to avoid short flash at last.
    document.getElementById("badsndAlert").style.visibility = "visible";
    document.getElementById("badsndAlert").style.animationPlayState = "running";
    clearTimeout(timer6);
    timer6 = setTimeout(hideBadSound, 4900);
}

function hideBadSound() {
    document.getElementById("badsndAlert").style.animationPlayState = "paused";
    document.getElementById("badsndAlert").style.visibility = "hidden";
}

function onGetComments(msg) {

    if (CommentProcessed == true) {
        //time out has already been executed, comment page skipped. No need to display the comment page
        return;
    }
    clearTimeout(timer2);
    CommentProcessed = true;

    var ele = document.getElementById("downloading");
    ele.parentNode.removeChild(ele);

    for (var i = 0; i < msg.length; i++) {
        var pNode = document.createElement("p");
        pNode.className = 'myp';

        var labelNode = document.createElement("label");
        var textNode = document.createTextNode(msg[i].comment);
        labelNode.appendChild(textNode);

        var inputNode = document.createElement("input");
        inputNode.className = 'myinput';
        inputNode.type = 'radio';
        inputNode.name = 'comment';
        inputNode.value = msg[i].idx;
        inputNode.onclick = onPredefinedAnswerClick;

        var hrNode = document.createElement("hr");

        pNode.appendChild(labelNode);
        pNode.appendChild(inputNode);
        document.getElementById("myform").appendChild(pNode);
        document.getElementById("myform").appendChild(hrNode);
    }
    commentIdx = 0;
    onTextAreaClicked();
}

function onQuit(iChecked) {

    inQuit = true;

    document.getElementById(mainPage).style.display = "none";
    document.getElementById('titlebar').style.visibility = "hidden";
    document.getElementById("totalresult-page").style.display = "none";
    document.getElementById("comment-page").style.visibility = "hidden";
    document.getElementById("comment-button-row").style.visibility = "hidden";
    document.getElementById("quit-page").style.visibility = "visible";
    document.getElementById("quit-button-row").style.visibility = "visible";

    initButton('quitButton', 'white');

    //	if(role == 'teller'){
    //		allReasons = commonQuitReasons.concat(tellerQuitReasons);
    //	} else if (role == 'listener'){
    //		allReasons = commonQuitReasons.concat(listenerQuitReasons);
    //	}

    for (var i = 0; i < allReasons.length; i++) {
        var pNode = document.createElement("p");
        pNode.className = 'myp';

        var labelNode = document.createElement("label");
        var textNode = document.createTextNode(allReasons[i]);
        labelNode.appendChild(textNode);

        var inputNode = document.createElement("input");
        inputNode.className = 'myinput';
        //		inputNode.type = 'checkbox';
        inputNode.type = 'radio';
        inputNode.name = 'reason';
        inputNode.value = 1;
        //		inputNode.onclick = onPredefinedAnswerClick;
        if (i == iChecked) {
            inputNode.checked = true;
        }
        var hrNode = document.createElement("hr");
        hrNode.color = 'white';

        pNode.appendChild(labelNode);
        pNode.appendChild(inputNode);
        document.getElementById("quitForm").appendChild(pNode);
        document.getElementById("quitForm").appendChild(hrNode);
    }
    commentIdx = 0;
    onTextAreaClicked();
}


//if network has no response for the comment list, skip and show a simple build-in comment list instead
function OnWaitComment() {
    if (CommentProcessed == false) {
        //		JavaScriptInterface.nativeCommand('msgBox', '评论已取消,服务器无响应');
        onGetComments(simAnswersMsg.info);
        CommentProcessed = true;
    }
}

function onExitButton() {

    if (isSimulation) {
        alert("exit");
    }

    JavaScriptInterface.nativeCommand('exit', '');
}

function onQuitButton() {

    var reasons = "";
    var choice = document.getElementsByName("reason");

    for (var i = 0; i < choice.length; i++) {
        if (choice[i].checked) {
            reasons += allReasons[i] + ';';
        }
    }
    requestServer("Game", "Quit", "reason=QUIT:" + reasons + "&matchidx=" + matchidx);
    sendPeerMsg('userquit');

    if (isSimulation) {
        alert("quit:" + reasons);
    }

    JavaScriptInterface.nativeCommand('exit', '');
}

function onCommentButton() {

    //	document.getElementById("totalresult-page").style.visibility = "hidden";
    document.getElementById("totalresult-page").style.display = "none";
    document.getElementById("comment-page").style.visibility = "visible";
    document.getElementById("comment-button-row").style.visibility = "visible";

    document.getElementById("comment-text").addEventListener("touchstart", onTextAreaClicked, false);
    document.getElementById("comment-text").addEventListener("mousedown", onTextAreaClicked, false);

    initButton('submitButton', 'white');

    requestServer("Game", "GetComments");
    CommentProcessed = false;
    timer2 = setTimeout(OnWaitComment, 8000);
}

function submitComment() {

    var param;

    if (commentIdx < 0) {
        param = 'idx=0&comment=' + simAnswersMsg.info[-commentIdx - 1].comment;
    } else {
        param = 'idx=' + commentIdx;
    }

    if (commentIdx == 0) {
        if (document.getElementById('comment-text').value == '') {
            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"评价为空，请输入评价\",\"t\":\"3\"}');
            return;
        } else {
            param += '&comment=' + document.getElementById('comment-text').value;
        }
    }

    requestServer("Game", "SubmitComment", param);

    if (isSimulation) {
        alert("comment & exit");
    }

    JavaScriptInterface.nativeCommand('exit', '');
}

function showFinalResult() {
    document.getElementById("result-page").style.visibility = "hidden";
    document.getElementById("totalresult-page").style.visibility = "visible";

    var names = pair.split(",");
    document.getElementById("totalscorelabel").innerHTML = names[0] + ' & ' + names[1];
    document.getElementById("totalscorelabel2").innerHTML = finishMsg.finishtime;
    document.getElementById("totalscore").innerHTML = finishMsg.totalscore

    showGameResult();

    initButton('exitButton', 'white', 'rgb(25,189,190)');
    //	initButton('exitButton', 'white');
    //	initButton('commentButton', 'white');

    if (role == 'teller') {
        if (finishMsg.otherexammsg != undefined && finishMsg.otherexammsg != '' && finishMsg.otherexammsg != null) {
            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"' + finishMsg.otherexammsg + '\",\"t\":\"6\"}');
        }
    } else {
        if (finishMsg.exammsg != undefined && finishMsg.exammsg != '' && finishMsg.exammsg != null) {
            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"' + finishMsg.exammsg + '\",\"t\":\"6\"}');
        }
    }
}

function onMyinputClick() {
    document.getElementById("comment-text").readOnly = false;
    document.getElementById("comment-text").style.color = 'white';
    commentIdx = 0;
}

function onTextAreaClicked() {
    document.getElementById("comment-text").readOnly = false;
    document.getElementById("comment-text").style.color = 'white';
    document.getElementById("firstRadio").checked = true;
    commentIdx = 0;
}

function onPredefinedAnswerClick() {
    document.getElementById("comment-text").readOnly = true;
    document.getElementById("comment-text").style.color = 'gray';
    commentIdx = this.value;
}

function onReport() {
    document.getElementById("otherReason").style.visibility = "hidden";
    document.getElementById('reasonInput').value = '';
    document.getElementById("report-menu").style.display = "block";
    document.getElementById("report-menu").style.zIndex = 800;
    initButton('sel1', 'white', 'rgb(25,189,190)');
    initButton('sel2', 'white', 'rgb(25,189,190)');
    initButton('sel3', 'white', 'rgb(25,189,190)');
    initButton('sel4', 'white', 'rgb(25,189,190)');
    //	setTimeout("document.getElementById('report-menu').style.display = 'none';", 6000);
}

function reportSel(sel) {
    if (sel != undefined) {
        requestServer("Game", "Report", "reason=" + sel);
		/*if(isSimulation){
			onNativeMsg('server', '{"code": 200}');
		}*/
    } else {
        if (document.getElementById('reasonInput').value == '') {
            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入举报理由\",\"t\":\"3\"}');
            return;
        } else {
            requestServer("Game", "Report", "reason=" + document.getElementById('reasonInput').value);
        }
    }
    document.getElementById("report-menu").style.display = "none";
}

function doOtherReason() {
    document.getElementById("otherReason").style.visibility = "visible";
}

function onNativeMsg(source, jMsg) {

    var msg = eval("(" + jMsg + ")");

    switch (source) {
        case 'server':
            if (msg.code == 602) {
                requestServer("GameLog", "Add", "logtype=CommError&details=S602" + jMsg);
                return;
            } else if (msg.code == 603 || msg.code == 604) {
                if (!quitSent) {
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"对方玩家已退出(800)\",\"t\":\"6\"}');
                    setTimeout("requestServer('Game', 'Quit', 'reason=OTHERQUIT&matchidx='+matchidx);", 3000);
                    quitSent = true;
                }
                timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 6000);
                return;
            } else if (msg.code != 200) {
                if (msg.code == 500 && msg.request == 'Report') {
                    return;
                }
                if (!quitSent) {
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"服务器无响应（' + msg.code + '）\",\"t\":\"6.0\"}');
                    requestServer("Game", "Quit", "reason=NET(srv):" + msg.code + "&matchidx=" + matchidx);
                    quitSent = true;
                }
                sendPeerMsg('quit');
                timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                return;
            }

            if (msg.request == 'GetInitInfo') {
                //			requestServer("GameLog", "Add", "GetInitInfo=ChgBG&details="+jMsg);
                if (msg.info.matchidx != undefined) {
                    matchidx = msg.info.matchidx;
                }
                break;
            }
            if (msg.request == 'GetComments') {
                onGetComments(msg.info);
                break;
            }
            if (msg.request == 'SubmitEmotion') {
                requestServer("GameLog", "Add", "logtype=SubmitEmotion&details=" + jMsg);
            }
            break;

        case 'peer':
            if (gameover || msg.matchid != matchidx) {
                return;
            }

            switch (msg.type) {
                case 'quit':
                    if (!quitSent) {
                        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"对方玩家异常退出(803)\",\"t\":\"6\"}');
                        requestServer("Game", "Quit", "reason=OTHERQUIT&matchidx=" + matchidx);
                        quitSent = true;
                    }
                    timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                    break;
                case 'userquit':
                    if (!quitSent) {
                        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"对方玩家主动退出(802)\",\"t\":\"6\"}');
                        requestServer("Game", "Quit", "reason=OTHERQUIT&matchidx=" + matchidx);
                        quitSent = true;
                    }
                    timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                    break;
                case 'heartbeat':
                    var beatTime = new Date();
                    if (beatTime.getTime() - lastBeatTime > 0) {
                        lastBeatTime = beatTime.getTime();
                    }
                    break;
                case 'badsound':
                    displayBadSound();
                    break;
            }
            break;

        case 'system':
            if (gameover) {
                switch (msg.code) {
                    case 220:
                    case '220':
                    case '220.0':
                        JavaScriptInterface.nativeCommand('ackBack', '');
                        if (inQuit) {
                            return;
                        }
                        requestServer("GameLog", "Add", "logtype=app_callback&details=query_user_quit");
                        if (nextGame == 2) {
                            keepBadNet = true;
                            if (badNet) {
                                JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"' + gameName + '\",\"msg\":\"确定要退出？\",\"lbtn\":\"取消\",\"rbtn\":\"确定\"}');
                            } else {
                                JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"' + gameName + '\",\"msg\":\"退出比赛将无法获得成绩，并禁言1分钟，扣减信用分10分。是否确定要退出？\",\"lbtn\":\"取消\",\"rbtn\":\"确定\"}');
                            }
                        } else if (nextGame == 3) {
                            JavaScriptInterface.nativeCommand('exit', '');
                        }
                        break;
                    case 221:
                    case '221':
                    case '221.0':
                        keepBadNet = false;
                        //cancel, do nothing
                        requestServer("GameLog", "Add", "logtype=app_callback&details=dialog_action:cancel_quit");
                        break;
                    case 222:
                    case '222':
                    case '222.0':
                        keepBadNet = false;
                        if (!quitSent) {
                            requestServer("Game", "Quit", "reason=QUIT:网络差&matchidx=" + matchidx);
                            quitSent = true;
                        }
                        sendPeerMsg('quit');
                        JavaScriptInterface.nativeCommand('exit', '');
                        break;
                }

                return;
            }

            switch (msg.code) {
                case 200:
                case '200':
                case '200.0':
                case 208:
                case '208':
                case '208.0':
                    if (role == 'teller' && msg.info != undefined) {
                        requestServer("Game", "SubmitChannelId", "channelid=" + msg.info);
                    }
                    break;
                case 201:
                case '201':
                case '201.0':
                    reconnectCount++;
                    if (reconnectCount < 3) {
                        JavaScriptInterface.nativeCommand('startVoice', '');
                    } else {
                        if (!quitSent) {
                            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"通信异常（201）\",\"t\":\"6\"}');
                            requestServer("Game", "Quit", "reason=NET(sys):201&matchidx=" + matchidx);
                            quitSent = true;
                        }
                        sendPeerMsg('quit');
                        timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                    }
                    break;
                case 204:
                case '204':
                case '204.0':
                    reconnectCount++;
                    if (reconnectCount > 2) {
                        if (!quitSent) {
                            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"通信异常（204）\",\"t\":\"6\"}');
                            requestServer("Game", "Quit", "reason=NET(sys):204&matchidx=" + matchidx);
                            quitSent = true;
                        }
                        sendPeerMsg('quit');

                        timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                    }
                    break;
                case 213:
                case '213':
                case '213.0':
                    // system notice for user quite is no longer used. Code reserved for future use
                    /*			if(!quitSent){
                                    JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"游戏结束\",\"msg\":\"对方玩家违例退出(801)\",\"t\":\"6\"}');
                                    requestServer("Game", "Quit", "reason=OTHERQUIT&matchidx="+matchidx);
                                    quitSent = true;
                                }
                                timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);*/
                    break;
                case 220:
                case '220':
                case '220.0':
                    JavaScriptInterface.nativeCommand('ackBack', '');
                    if (inQuit) {
                        return;
                    }
                    requestServer("GameLog", "Add", "logtype=app_callback&details=query_user_quit");
                    keepBadNet = true;
                    if (badNet) {
                        JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"' + gameName + '\",\"msg\":\"确定要退出？\",\"lbtn\":\"取消\",\"rbtn\":\"确定\"}');
                    } else {
                        JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"' + gameName + '\",\"msg\":\"退出比赛将无法获得成绩，并禁言1分钟，扣减信用分10分。是否确定要退出？\",\"lbtn\":\"取消\",\"rbtn\":\"确定\"}');
                    }
                    break;
                case 221:
                case '221':
                case '221.0':
                    //cancel, do nothing
                    keepBadNet = false;
                    requestServer("GameLog", "Add", "logtype=app_callback&details=dialog_action:cancel_quit");
                    break;
                case 222:
                case '222':
                case '222.0':
                    keepBadNet = false;
                    if (!quitSent) {
                        if (badNet) {
                            //					onQuit(0);
                            if (!quitSent) {
                                requestServer("Game", "Quit", "reason=QUIT:网络差&matchidx=" + matchidx);
                                quitSent = true;
                            }
                            sendPeerMsg('quit');
                            timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                        } else {
                            onQuit(-1);
                        }
                    }
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    initStepTwo();
                    break;
                /*		case 224:
                        case '224':
                        case '224.0':
                            pair = msg.info;
                            break;*/
                case 232:
                case '232':
                case '232.0':
                    requestServer("GamePS2", "Switch", "back=true");
                    break;
                case 233:
                case '233':
                case '233.0':
                    //do nothing when foreground/background switch, just to avoid default process
                    requestServer("GamePS2", "Switch", "back=false");
                    break;
                case 202:
                case '202':
                case '202.0':
                case 203:
                case '203':
                case '203.0':
                case 205:
                case '205':
                case '205.0':
                case 206:
                case '206':
                case '206.0':
                case 207:
                case '207':
                case '207.0':
                case 210:
                case '210':
                case '210.0':
                case 211:
                case '211':
                case '211.0':
                case 212:
                case '212':
                case '212.0':
                    if (!quitSent) {
                        requestServer("GameLog", "Add", "logtype=commError&details=param:" + source + "," + jMsg);
                        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"比赛中止\",\"msg\":\"通信异常（' + msg.code + '）\",\"t\":\"6\"}');
                        requestServer("Game", "Quit", "reason=NET(sys):" + msg.code + "&matchidx=" + matchidx);
                        quitSent = true;
                    }
                    sendPeerMsg('quit');
                    timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                    break;
            }
    }

    onGameNativeMsg(source, msg);
}
