﻿
var app = new Vue({
    el: "#app",
    data: {
        init: false,
        width: 0,
        height: 0,
        style: "",
        qs: [
            "沟通中我能清晰地表达自己的观点",
            "沟通中我能根据对方的理解程度调整表达策略",
            "沟通中我经常主动寻求反馈来确认对方是否准确理解",
            "沟通中我总是仔细倾听",
            "沟通中对于不理解的地方，我会及时表达疑问",
            "沟通中我能及时反馈来确认自己是否理解正确"
        ],
        checked: [0, 0, 0, 0, 0, 0],
        submitdate: '2019-09-10',
        submitted : false,
        readonly: false
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.width =
            window.innerWidth ||
            document.documentElement.clientWidth ||
            document.body.clientWidth;
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "height: " + (this.height - 118) + "px";
    },
    computed: {},
    methods: {
        checkok: function checkok() {
            if (this.submitted) return false;

            var ret = true;
            this.checked.forEach(function (d) {
                if (d == 0) {
                    ret = false;
                }
            });
            return ret;
        },
        //选择
        tapItem: function tapItem(idx, val) {
            //this.checked[idx] = val
            if (!this.readonly) {
                Vue.set(this.checked, idx, val);
            }

            console.log(idx, val);
        },
        // 确定
        tapConfirm: function tapConfirm() {
            if (!this.checkok()) return;
            this.submitted = true;
            var result = "";
            this.checked.forEach(function (d) {
                result = result + d;
            });
            console.log(result);
            submitAssess(result);
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});

function submitAssess(result) {
    var postinfo = '{"result": "' + result + '"}';
    var param = 'result=' + result;
    if (isSimulation) {
        alert(param);
    }
    else {
        requestServer("User/PostUserAssess", param, postinfo);
    }
}
sim.assess = '{ "code": 200, "info": { "results": [ 1, 3, 2, 5, 5, 4 ], "status": true, "submitdate":"2019-10-12" }, "request": "GetUserAssess" }';

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.assess;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"沟通习惯自评\"}');
        requestServer("User/GetUserAssess");
    }
}

function showInfo(msg) {
    app.checked = msg.info.results;
    app.readonly = !msg.info.status;
    app.submitdate = msg.info.submitdate;
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':
            flag = false;
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetUserAssess")
                    showInfo(msg);
                else if (msg.request == "PostUserAssess") {
                    if (msg.info.more == 0) {
                        if (msg.info.award == 0) {
                            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"提交成功！\",\"t\":\"3\"}');
                            setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 2200);
                        }
                        else {
                            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"恭喜你\",\"msg\":\"提交成功！获得双倍券奖励！\",\"t\":\"3\"}');
                            setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 2200);
                        }
                    }
                    else {
                        if (msg.info.award == 0) {
                            JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"提示\",\"msg\":\"提交成功！填写求职意向可获得2张额外双倍券奖励。\",\"lbtn\":\"前往填写\",\"rbtn\":\"以后再说\"}');
                        }
                        else {
                            JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"恭喜你\",\"msg\":\"获得双倍券奖励！填写求职意向还可获得两张额外双倍券奖励。\",\"lbtn\":\"再拿两张双倍券\",\"rbtn\":\"以后再说\"}');
                        }

                    }
                    //window.location.href = "my.html";
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    //window.location.href = "my.html";
                    break;
                case 221:
                case '221':
                case '221.0':
                    window.location.href = "job.html";
                    break;
                case 222:
                case '222':
                case '222.0':
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                default:
                    break;
            }
    }
}