
function getInfo() {
    if (isSimulation) {
        var jMsg = sim.dailystat;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜\"}');
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"成绩曲线\"}');
        var gamecode = GetQueryString("gamecode");
        requestServer("Exam/GetUserDailyStat", "gamecode=" + gamecode);
    }
}

function showhis() {
    var gamecode = GetQueryString("gamecode");
    window.location.href = "matchhis2.html?gamecode=" + gamecode;
}

function showInfo(msg) {
    // 指定图表的配置项和数据
    var option = {
        title: {
            text: ''
        },
        tooltip: {
            trigger: 'axis'
        },
        legend: {
            data: ['最高分', '平均分', '最低分'],
            left: 'right',
            top: 32
        },
        grid: {
            left: '5%',
            right: '8%',
            bottom: '3%',
            top: 80,
            containLabel: true
        },
        toolbox: {
            feature: {
                //saveAsImage: {}
            }
        },
        xAxis: {
            type: 'category',
            boundaryGap: false,
            data: []
        },
        yAxis: {
            type: 'value'
        },
        series: [
            //{
            //    name: '最高分',
            //    type: 'line',
            //    data: [120, 132, 101, 134, 90, 230, 210]
            //},
            //{
            //    name: '平均分',
            //    type: 'line',
            //    data: [220, 182, 191, 234, 290, 330, 310]
            //},
            //{
            //    name: '最低分',
            //    type: 'line',
            //    data: [150, 232, 201, 154, 190, 330, 410]
            //}
        ]
    };
    var myChart = echarts.init(document.getElementById('main'));
    var dates = [];
    var maxs = [];
    var mins = [];
    var avgs = [];

    for (var i = 0; i < msg.info.stat.length; i++) {
        var ex = msg.info.stat[i];
        dates.push(ex.date);
        maxs.push(ex.max);
        mins.push(ex.min);
        avgs.push(ex.avg);
    }
    option.xAxis.data = dates;
    option.series.push({ name: '最高分', type: 'line', data: maxs });
    option.series.push({ name: '平均分', type: 'line', data: avgs });
    option.series.push({ name: '最低分', type: 'line', data: mins });

    option.title.text = "每日成绩";

    // 使用刚指定的配置项和数据显示图表。
    myChart.setOption(option);
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetUserDailyStat':
                    showInfo(msg);

                    break;
            }
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    window.location.href = "myscore2.html";
                    break;
                default:
                    break;
            }
            break;
    }
}

