﻿/*
 * Game Lib (B) version 1.2 (Jun 1, 2019)
 */
 
var debug = false;
var isSimulation = false;

var base = "api/";
var apiCode = "GamePA";
var gameName = "说服";
var myVue;
 
var token;
var matchidx = 0;
var screenWidth = 100;
var screenHeight = 100;

if(isSimulation){
	var JavaScriptInterface = null;
}
var timer1, timer4;


function requestServer(game, request, parameter){
	
	if(JavaScriptInterface == null || JavaScriptInterface == undefined || token == undefined){
		return;
	}
	
	var url = base + game + "/" + request + "?token=" + token;
	if(parameter != null){
		url = url + "&" + parameter;
	}

	JavaScriptInterface.nativeSendMsg(encodeURI(url), '');
	
	if(debug){
		document.getElementById('debug').innerHTML += 'url: ' + url;
	}
}

function sendPeerMsg(type, msg){
	if(msg == undefined || msg == null){
		var msg = new Object();
	}
	msg.type = type;
	msg.matchid = matchidx;
	var jMsg = JSON.stringify(msg);
	JavaScriptInterface.nativeSendMsg('peer', jMsg);
	if(type == 'finish'){
//		requestServer("GameLog", "Add", "logtype=Debug&details=finish_detail"+jMsg);
	}
}

//waiting for initialization of the native-JS interface, to guarantee the successful getToken
function onGameLoad(){
	timer1 = setTimeout(initStepOne, 1000);
}

function initStepOne(){

	var sUserAgent = navigator.userAgent.toLowerCase();  
	var isIOS = (sUserAgent.match("ipad") == "ipad") || (sUserAgent.match("iphone") == "iphone");
	
	if(isIOS){
		JavaScriptInterface = new Object();
		JavaScriptInterface.nativeCommand = function(cmd, param){
			window.webkit.messageHandlers.nativeCommand.postMessage({"cmd":cmd,"param":param});
		}
		JavaScriptInterface.nativeSendMsg = function(dest, msg){
			window.webkit.messageHandlers.nativeSendMsg.postMessage({"dest":dest,"msg":msg});
		}		
	}
	
	if(isSimulation){
		//simulate the native object
		JavaScriptInterface = new Object();
		JavaScriptInterface.nativeSendMsg = function(dest, msg){
//			document.getElementById('debug').innerHTML = 'dest: ' + dest + '<br />msg: ' + msg;
		};
		JavaScriptInterface.nativeCommand = function(cmd, param){
//			document.getElementById('debug').innerHTML = 'cmd: ' + cmd + '<br />param: ' + param;
		};		
	}
	
	if(debug){
		document.getElementById('debug').style.visibility = "visible";
//		document.getElementById('comment-page').style.height = "85%";
//		document.getElementById('comment-page').style.bottom = "15%";
	}
	
	JavaScriptInterface.nativeCommand('getToken', '');
	if(isSimulation){
		token = '000000';
		initStepTwo();
	}
	if(debug){
		document.getElementById('debug').innerHTML += '\ngettokwn';
	}
}

//callback by APP when token is given
function initStepTwo(){
	
	if(token == null || token == undefined){
		JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"未能获取token(810)\",\"t\":\"6\"}');
		requestServer("Game", "Quit", "reason=NET:no_token&matchidx="+matchidx);
		timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
	}
			
	screenWidth = document.body.clientWidth;
	screenHeight = document.body.clientHeight;
	
	requestInitInfo();
//	requestServer(apiCode, "GetInitInfo");
}

/*
function initButton(id, pressedTextColor){
	document.getElementById(id).style.visibility = "visible";
	document.getElementById(id).addEventListener("touchstart", onTouchButton, true);
	document.getElementById(id).addEventListener("touchend", onLeaveButton, true);
	document.getElementById(id).btnTextColor = window.getComputedStyle(document.getElementById(id)).color;
	if(pressedTextColor != null){
		document.getElementById(id).pressedTextColor = pressedTextColor;
	} else {
		document.getElementById(id).pressedTextColor = document.getElementById(id).btnTextColor;
	}
}

function disableButton(btn){
	btn.disabled = true;
	btn.style.color = 'lightgray';
	btn.style.borderColor = 'lightgray';
	btn.removeEventListener("touchstart", onTouchButton, true);
	btn.removeEventListener("touchend", onLeaveButton, true);
}

function onTouchButton(e){
	if(!e.target.selected){
		e.target.style.backgroundColor = window.getComputedStyle(e.target).borderColor;
		e.target.style.color = e.target.pressedTextColor;
	}
}

function onLeaveButton(e){
	if(!e.target.selected){
		e.target.style.backgroundColor = "transparent";
		e.target.style.color = e.target.btnTextColor;
	}
}
*/

function onNativeMsg(source, jMsg){
	
	var msg = eval("(" + jMsg + ")");
	
	switch(source){
	case 'server':
/*		if(msg.code == 500 && (msg.request == 'GetInitInfo' || msg.request == 'GetPreScore')){
			//重发
			requestServer(apiCode, msg.request);
			return;
		} else if(msg.code == 603 || msg.code == 604){
			doExit("游戏已终止。");
			return;
		} else if(msg.code != 200){
			doExit("服务器无响应，游戏退出。");
			return;
		}*/
		if(msg.code == 603 || msg.code == 604){
			doExit("游戏已终止。");
			return;
		} else if(msg.code == 500){
			doExit("服务器无响应，游戏退出。");
			return;
		}
	
		if(msg.request == 'GetInitInfo' || msg.request == 'GetMatchStatusInfo' || msg.request == 'GameAction' || msg.request == 'GetPreScore'){
			if(msg.info.matchidx != undefined){
				matchidx = msg.info.matchidx;
			}
		}
		break;
	case 'system':
		switch(msg.code)
		{
		case 220:
		case '220':
		case '220.0':
			JavaScriptInterface.nativeCommand('ackBack', '');
			JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"游戏进行中，不能退出\",\"t\":\"1\"}');
			break;
		case 223:
		case '223':
		case '223.0':
			token = msg.info;
			if(debug){
				document.getElementById('debug').innerHTML += '\ntoken: ' + msg.info;
			}
			initStepTwo();
			break;
		}
	}

	onGameNativeMsg(source, msg);
}

function doExit(msgText){
	JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"'+msgText+'请重新进入\",\"t\":\"3\"}');
//	requestServer(apiCode, "GameAction", "act=53");
	if(step == 3){
		sendPeerMsg('MatchStatusChanged');
	}
	setTimeout("JavaScriptInterface.nativeCommand('exit', '')",3000);
}
