"use strict";
var myVue = {};
Vue.use(VueAwesomeSwiper);
var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        swiperOption: {
            navigation: {
                nextEl: ".swiper-button-next",
                prevEl: ".swiper-button-prev"
            }
        },
        activeIndex: 0,
        slideInfo: [],
    },
    components: {
        LocalSwiper: VueAwesomeSwiper.swiper,
        LocalSlide: VueAwesomeSwiper.swiperSlide
    },
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {
        swiper: function swiper() {
            return this.$refs.awesomeSwiper.swiper;
        }
    },
    methods: {
        tap: function tap() {
            console.log("tap");
        },
        onSetTranslate: function onSetTranslate() {
            this.activeIndex = this.swiper.activeIndex;
            setTitle(this.slideInfo[this.activeIndex].title); //        this.activeIndex = this.$refs.awesomeSwiper.swiper.activeIndex
            //       console.log('onSetTranslate')
        }
    },
    created: function created() {
        myVue = this;
    },
    mounted: function mounted() {
        this.init = true;
    }
});


function setTitle(title) {
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"' + title + '\"}');
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.entrank0;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜\"}');
        var ranktype = GetQueryString("ranktype");
        if (ranktype == null)
            ranktype = "a";
        requestServer("Exam/GetEntRanks", "ranktype=" + ranktype);
    }
}

function showInfo(msg) {
    myVue.slideInfo = msg.info.rankinfos;
    setTitle(myVue.slideInfo[0].title);
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetEntRanks':
                    showInfo(msg);
                    break;
            }
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                default:
                    break;
            }
            break;
    }
}

