﻿"use strict";
var app = new Vue({
    el: "#app",
    data: {
        init: false,
        matchidx: 0,
        gamecode: "",
        gametype: 3,
        score1: 0,
        exp1: 0,
        score2: 0,
        exp2: 0,
        fidx: 0,
        fname: "",
        levelname: "",
        gametime: "",
        roundcount: 2,
        today: false,
        r: -1,
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        tapApply: function tapApply() {
            Apply();
        },
        tapDelete: function tapDelete() {
            Delete();
        },
        showDetail: function showDetail(round) {
            var url = "../gamePS2N/Review.html?matchidx=" + app.matchidx + "&round=" + round;
            //MsgBox("url", url);
            window.location.href = url;
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});

function getInfo() {
    SetTitle("比赛详情");
    app.gamecode = GetQueryString("gamecode");
    app.matchidx = GetQueryString("midx");
    var gametype = GetQueryString("gametype");
    if (gametype != null && gametype != undefined)
        app.gametype = gametype;

    if (isSimulation) {
        var jMsg = sim.matchinfo;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        requestServer("Exam/GetUserMatchInfo", "matchidx=" + app.matchidx + "&gametype=" + app.gametype);
    }
}

function showInfo(msg) {
    app.score1 = msg.info.score1 < 0 ? 0 : msg.info.score1;
    app.exp1 = msg.info.exp1;
    app.score2 = msg.info.score2 < 0 ? 0 : msg.info.score2;
    app.exp2 = msg.info.exp2;
    app.fidx = msg.info.fidx;
    app.fname = msg.info.fname;
    app.levelname = msg.info.levelname;
    app.gametime = msg.info.gametime;
    app.today = msg.info.today;
    app.roundcount = msg.info.roundcount;
    getRelationship();
}

function getRelationship() {
    if (isSimulation) {
        var msgr = eval("(" + sim.relationship + ")");
        showRelationship(msgr);
    }
    else {
        requestServer("Friend/Relationship", "touser=" + app.fidx);
    }
}

function showRelationship(msg) {
    app.r = msg.info.r;
}

function goBack() {
    window.history.back();
    //if (app.gamecode == "") {
    //    window.location.href = "myscore.html";
    //}
    //else {
    //    window.location.href = "chart.html?gamecode=" + app.gamecode;
    //}
}

function Apply() {
    if (isSimulation) {
        app.r = 1;
    } else {
        //app.curritem = item;
        requestServer("Friend/Apply", "touser=" + app.fidx);
    }
}

function Delete() {
    //MsgBox("Del", index);
    if (isSimulation) {
        goBack();
    } else {
        requestServer("Friend/Delete", "touser=" + app.fidx);
    }
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetUserMatchInfo") {
                    showInfo(msg);
                }
                else if (msg.request == "Relationship") {
                    showRelationship(msg);
                }
                else if (msg.request == "Apply") {
                    showRelationship(msg);
                }
                else if (msg.request == "Delete") {
                    goBack();
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    goBack();
                    //window.location.href = "my.html";
                    break;
                default:
                    break;
            }
    }
}