﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        lockercount: 0,
       // selected: true,
        style: "",
        audio: null,
        deadline: 0,
        //time: 30,
        timeText: "",
        maintitle: "排名打分",
        title: "",
        descript: "",
        prescorecount: 0,
        btnText: "确认选择",
        items: [
            {
                title: " ",
                role: " ",
                count: 0
            },
            {
                title: " ",
                role: " ",
                count: 0
            },
            {
                title: " ",
                role: " ",
                count: 0
            },
            {
                title: " ",
                role: " ",
                count: 0
            }
        ],
        rankType: 1,
        allsortnumber: 1,
        gamecode: 'PA',
        titlespa: ["陈述", "犀利", "懂我"],
        descriptspa: [
            "最能清晰说明自己的观点",
            "最能发现并指出他人观点中的漏洞和盲点",
            "最能理解我的想法"
        ],
        titlespam: ["说服力", "积极", "亲和"],
        descriptspam: [
            "Ta讲得很有道理，我愿意接受Ta的意见",
            "积极参与沟通，主动回应队友的观点",
            "语气友好，让人容易信任和接近"
        ],
        array: []
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
        this.audio = document.createElement("audio");
        this.audio.src = "./sound/ready.mp3";
    },
    computed: {},
    methods: {
        // 初始化选项
        initinfo: function initinfo(prescorecount, gamecode, json, ranktype, allsortnumber) {
            this.prescorecount = prescorecount;
            this.gamecode = gamecode;
            if (prescorecount == 0) {
                this.items = json;
                this.array = [];
            }
            else {
                this.items = [];
                this.array = json.sort(this.sortcount);
            }
            //this.selected = false;
            this.rankType = ranktype;
            this.allsortnum = allsortnumber;

            if (this.gamecode == "PA") {
                this.title = this.titlespa[ranktype - 1];
                this.descript = this.descriptspa[ranktype - 1];
            }
            else {
                this.title = this.titlespam[ranktype - 1];
                this.descript = this.descriptspam[ranktype - 1];
            }

            this.maintitle =
                this.title +
                "(" +
                ranktype +
                "/" +
                allsortnumber +
                ")";
            SetTitle(this.maintitle);
            if (ranktype == 1)
                this.audio.play();
        },
        sortcount: function sortcount(a, b) {
            return b.count - a.count;
        },
        updatetime: function updatetime(countdown) {
            this.deadline = new Date().getTime() + countdown - 2000; //this.time = parseInt(countdown / 1000 + 1)
        },
        // 倒计时
        timer: function timer() {
            if (this.deadline == 0) {
                // 操作时限：30秒
                this.deadline = new Date().getTime() + 90000;
            }

            this.lockercount--;

            var diff = this.deadline - new Date().getTime();
            var time = parseInt((diff + 500) / 1000);

            if (diff > 0) {
                time = time == 0 ? 1 : time;
                this.timeText = time < 10 ? "0" + time : "" + time; // 1~1499 -> n

                var interval = diff - (time - 1) * 1000;
                setTimeout(this.timer, interval);
            } else if (diff > -3000) {
                time = 0;
                this.timeText = "0";
                this.tap();
                console.log("getinfo 1");
                getInfo(); //this.selected = true
            } else {
                console.log("getinfo 2");
                getInfo();
            }
        },
        // 确认
        tap: function tap() {
            var result = "";
            if (0 != this.items.length) return;
            this.array.forEach(function (d) {
                result = result + d.role;
            });
            if (this.lockercount > 0) return;
            this.lockercount = 5;
            if (result == "") {
                this.lockercount = 0;
                return;
            }
            //console.log(result);
            submitSort(result);
        },
        tapItem: function tapItem(idx) {
            console.log(idx);
            this.array.push(this.items[idx]);
            this.items.splice(idx, 1);

            if (1 == this.items.length) {
                this.array.push(this.items[0]);
                this.items.splice(0, 1);
            }

            //if (0 == this.items.length) this.selected = false;
        },
        tapUp: function tapUp(idx) {
            console.log(idx);
            this.array[idx - 1] = this.array.splice(idx, 1, this.array[idx - 1])[0];
        },
        tapDown: function tapDown(idx) {
            this.array[idx + 1] = this.array.splice(idx, 1, this.array[idx + 1])[0];
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
        this.timer();
    }
});

function submitSort(result) {
    if (isSimulation) {
        alert(app.rankType + "_" + result);
    } else {
        requestServer(
            "GamePA/Sort",
            "ranktype=" + app.rankType + "&result=" + result
        );
    }
}

var initOptions = false;

function initInfo(msg) {
    var matchIdx = msg.info.matchidx;

    if (!leave) {
        leaveRoom(matchIdx);
    }

    switch (msg.info.stage) {
        case 1:
            window.location.href = "pa_one.html";
            break;
        case 2:
            //				window.location.href = "pa_two.html";
            var time = Math.round((msg.info.countdown + 500) / 1000);
            window.location.href = "pa_two.html?t=" + time;
            break;
        case 4:
            //				window.location.href = "pa_three.html";
            window.location.href = "pa_two.html?t=0";
            break;
        case 5:
            if (msg.info.allsortnum == msg.info.sortnum) {
                window.location.href = "five.html";
            } else {
                if (!initOptions) {
                    initOptions = true;
                    app.initinfo(msg.info.prescorecount, msg.info.gamecode, msg.info.roles, msg.info.sortnum + 1, msg.info.allsortnum);
                }
                app.updatetime(msg.info.countdown);
                setTimeout(app.timer, 1000);
                app.lockercount = 0;
            }
            break;
        case 6:
            window.location.href = "six.html";
    }
}

var leave = false;

function leaveRoom(roomName) {
    if (isSimulation) {
        leave = true;
    } else {
        JavaScriptInterface.nativeCommand(
            "leaveRoom",
            '{"name":"' + roomName + '"}'
        );
    }
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.appfour;
        var msg = eval("(" + jMsg + ")");
        initInfo(msg);
    } else {
        JavaScriptInterface.nativeCommand("micOff", "");
        requestServer("GamePA/GetMatchStatusInfo");
    }
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "Sort") {
                    initOptions = false;
                }
                initInfo(msg);
            }
            else {
                if (msg.request != "GetMatchStatusInfo") {
                    getInfo();
                }
                else {
                    app.lockercount = 0;
                }                
            }
            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.location.href = "my.html";
                    MsgBox("提示", "比赛进行中，无法退出！");
                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;

                case 225:
                case "225":
                case "225.0":
                    break;

                case 230:
                case "230":
                case "230.0":
                    leave = true;

                default:
                    break;
            }
    }
}
