"use strict";
var myVue = {};
var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        slideStyle: "",
        activeIndex: 0,
        pageTitle: [],
        items: []
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
        this.slideStyle = "height: " + (this.height - 160) + "px";
    },
    computed: {},
    methods: {
        onSetTranslate: function onSetTranslate() {
            this.activeIndex = this.swiper.activeIndex; //console.log('activeIndex', this.swiper.activeIndex)

            setTitle(this.pageTitle[this.activeIndex]);
        }
    },
    created: function created() {
        myVue = this;
    },
    mounted: function mounted() {
        this.init = true;
    }
});


function setTitle(title) {
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"' + title + '\"}');
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.matchhis;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"比赛历史\"}');
        var gamecode = GetQueryString("gamecode");
        if (gamecode) {
            requestServer("Exam/GetUserMatchHis", "gamecode=" + gamecode);
        }
        else {
            requestServer("Exam/GetUserMatchHis");
        }
    }
}

function showInfo(msg) {
    //myVue.pageTitle = new Array();
    //myVue.pageTitle[0] = '我的战绩';
    //myVue.items[0] = new Array();
    for (var i = 0; i < msg.info.matchs.length; i++) {
        myVue.items.push({ type: getGameName(msg.info.matchs[i].gamecode), time: msg.info.matchs[i].datetime, value: msg.info.matchs[i].score    });
        //myVue.items[0][i].type = getGameName(msg.info.matchs[i].gamecode);
        //myVue.items[0][i].time = msg.info.matchs[i].datetime;
        //myVue.items[0][i].value = msg.info.matchs[i].score;
    }
}

function getGameName(gamecode) {
    switch (gamecode) {
        case 'PS2S': return '沟通成本';
        case 'PS2C': return '说人话';
        case 'PA': return '有效说服';
        case 'PAM': return '面试沟通';
        case 'PAN': return '面试沟通';
    }
    return "";
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetUserMatchHis':
                    showInfo(msg);
                    break;
            };
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    window.location.href = "myscore.html";
                    break;
                default:
                    break;
            }
            break;
    }
}

