﻿"use strict";

var step = 1; //组队

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: '',
        audio: null,
        ready: false,
        audioplayed: false,
        // true: 匹配成功
        time: 12,
        //timeText: '0',
        status: '匹配成功。组队中...',
        tapTime: new Date(),
        //btnText: '准备好了，进入',
        start: false // 确定进入

    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
        this.style = "min-height: ".concat(this.height, "px");
        this.audio = document.createElement("audio");
        this.audio.src = "./sound/ready.mp3";
    },
    computed: {
        btnText: function () {
            if (this.start) {
                return "正在进入...";
            } else {
                return "准备好了，进入";
            }
        },
        timeText: function () {
            if (this.time < 0) {
                return "0";
            }
            else {
                return "".concat(this.time);
            }
        }
    },
    methods: {
        // 倒计时
        timer: function timer() {
            if (this.time > 0) {
                this.time--;
                //this.timeText = "".concat(this.time);

                setTimeout(this.timer, 1000);
                requestServer(apiCode, "GetMatchStatusInfo");
            } else {
                //alert('倒计时结束')
                this.ready = true;
                this.status = "组队失败";
                document.getElementById('enterBtn').style.visibility = "hidden";
                requestServer(apiCode, "GameAction", "act=92");
                setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
            }
        },
        // 准备好了
        tapReady: function tapReady() {
            //        alert('进入')
            if (new Date() - this.tapTime < 1000)
                return;
            this.tapTime = new Date();
            console.log("tap");
            //this.start = true;
            //this.btnText = '正在进入';
            requestServer(apiCode, "GameAction", "act=11");

            if (isSimulation) {
                window.location.href = "pa_two.html";
            }
        }
    },
    created: function created() {
        myVue = this;
    },
    mounted: function mounted() {
        this.init = true;
        //this.audio.play();
        this.timer();
    }
});

function requestInitInfo() {
    SetTitle("有效说服");
}

function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetMatchStatusInfo':
                case 'GameAction':
                    switch (msg.info.stage) {
                        case 1:
                            if (msg.info.ready != undefined) {
                                for (var i = 1; i < msg.info.ready.length + 1; i++) {
                                    if (msg.info.ready[i - 1]) {
                                        document.getElementById("av" + i).classList.add("active");
                                    }
                                }
                            }

                            myVue.time = Math.round((msg.info.countdown + 500) / 1000);
                            //myVue.timeText = "".concat(myVue.time);
                            if (!app.audioplayed) {
                                app.audio.play();
                                app.audioplayed = true;
                            }
							myVue.start = msg.info.myready;
                            break;

                        case 2:
                            //				window.location.href = "pa_two.html";
                            var time = Math.round((msg.info.countdown + 500) / 1000);
                            window.location.href = "pa_two.html?t=" + time;
                            break;

                        case 4:
                            //				window.location.href = "pa_three.html";
                            window.location.href = "pa_two.html?t=0";
                            break;

                        case 5:
                            if (msg.info.allsortnum == msg.info.sortnum) {
                                window.location.href = "five.html";
                            } else {
                                window.location.href = "four.html";
                            }

                            break;

                        case 6:
                            window.location.href = "six.html";
                    }

                    break;
            }

            break;

        case 'system':
            switch (msg.code) {
                case 232:
                case '232':
                case '232.0':
                    requestServer(apiCode, "GameAction", "act=52");
                    break;

                case 233:
                case '233':
                case '233.0':
                    requestServer(apiCode, "GameAction", "act=51");
                    break;
            }

    }
}