﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        waitinfo: "预计需要10秒",
        time: 0,
        timeText: "00:00",
        url: "",
        tips: [],
        ti: 7,
        tip: "",
        tipcount: 0,
        style: ""
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        // 倒计时
        timer: function timer() {
            this.time++;
            var mi = parseInt(this.time / 60);
            var sec = this.time % 60;
            this.timeText =
                (mi < 10 ? "0" + mi : "" + mi) +
                ":" +
                (sec < 10 ? "0" + sec : "" + sec);
            getResult();

            if (this.tips.length > 0 && this.ti > 0) {
                this.tipcount++;
                this.tip = this.tips[
                    parseInt((this.tipcount / this.ti) % this.tips.length)
                ];
            }

            setTimeout(this.timer, 1000);
        }
    },
    created: function created() { },
    mounted: function mounted() {
        setTimeout(this.timer, 1000);
    }
});

function initInfo(msg) {
    //switch (msg.code) {
    //    case 607:
    //    case '607':
    //    case '607.0':
    //        window.location.href = msg.info.url;
    //        break;
    //    case 606:
    //    case '606':
    //    case '606.0':
    //        MsgBox('提示', '正在其它比赛中，无法进入！');
    //        setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
    //        break;
    //}
    app.waitinfo = msg.info.waitinfo;
    app.ti = msg.info.ti;
    app.url = msg.info.url;
    app.tips = msg.info.tips;
    SetTitle(msg.info.title); //window.location.href = "six.html";
}

var idx = GetQueryString("idx");
var level = GetQueryString("level");
var back = 0;

function getInfo() {
    if (isSimulation) {
        console.log("getInfo");
        var jMsg = sim.join;
        var msg = eval("(" + jMsg + ")");
        initInfo(msg);
    } else {
        if (level < 0) {
            toProtal();
        } else {
            // 再次调用关闭语音，避免之前比赛意外退出没有关闭语音的情况
            JavaScriptInterface.nativeCommand("endVoice", "");
            JavaScriptInterface.nativeCommand('getValue', '{\"key\":\"MFO\"}');
        }
    }
} // JavaScript source code

function join(friendonly) {
    requestServer("Game/JoinByIdx", "idx=" + idx + "&level=" + level + "&friendonly=" + friendonly);
}

function pairResult(msg) {
    if (msg.code == 200) {
        if (msg.info.result > 0) {
            setPairUsers(msg);
            window.location.href = app.url;
            //if (app.url.indexOf("?") > 0)
            //    window.location.href = app.url + "&t=" + new Date().getTime();
            //else 
            //    window.location.href = app.url + "?t=" + new Date().getTime();
        }
    } else if (msg.code == 605) {
        // 已配对成功，等待查询结果处理
    } else {
        toProtal();
    }
}

function toProtal() {
    if (back == 1) {
        MsgBox("提示", "APP刚才被切到后台了，需要重新进入", 3);
    }

    window.location.href = "portal.html?idx=" + idx + "&back=" + back;
}

function setPairUsers(msg) {
    var json = '{"paris":[';

    for (var i = 0; i < msg.info.other.length; i++) {
        if (i > 0) json = json + ",";
        json =
            json +
            '{"nickname":"' +
            msg.info.other[i].nickname +
            '", "role":"' +
            msg.info.other[i].role +
            '", "acc_id":"' +
            msg.info.other[i].acc_id +
            '"}';
    }

    json = json + "]}";

    if (isSimulation) {
        console.log(json);
    } else {
        JavaScriptInterface.nativeCommand("pairUsers", json);
    }
}

function getResult() {
    if (isSimulation) {
        var jMsg = sim.getpairresult;
        var msg = eval("(" + jMsg + ")");
        console.log("GetPairResult");
        pairResult(msg);
    } else {
        requestServer("Game/GetPairResult");
    }
}

function cancel() {
    if (isSimulation) {
        toProtal();
    } else {
        requestServer("Game/Cancel");
    }
}

function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case "server":
            if (msg.request == "JoinByIdx") initInfo(msg);
            else pairResult(msg);
            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.location.href = "my.html";
                    //MsgBox("提示", "比赛进行中，无法退出！");
                    cancel();
                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;

                case 232:
                case "232":
                case "232.0":
                    back = 1;
                    cancel();
                    break;
                case 237:
                case "237":
                case "237.0":
                    //MsgBox("提示", msg.info);
                    if (msg.info == "MFO_") {
                        //app.tohelp();
                        join(false);
                    }
                    else {
                        join(true);
                    }

                    break;
                default:
                    break;
            }
    }
}
