﻿"use strict";
var examidx = GetQueryString("examidx");

var app = new Vue({
    el: "#app",
    data: {
        title: "说人话",
        status: 2,
        //0 已结束，1 将要开始， 2正在进行中
        time: 20,
        timeText: "",
        style: "",
        levels: [
            {
                Level: 0,
                Name: "难度一"
            },
            {
                Level: 1,
                Name: "难度二"
            },
            {
                Level: 2,
                Name: "难度三"
            }
        ],
        part: 0,
        username: "",
        groupname: "",
        licensekey: "",
        prompt: "",
        userlevel: 0,
        gametype: 3,
        ban: 0,
        helpurl: "",
        guideurl: "",
        trainingurl: "",
        ruleurl: "",
        pophelp: false,
        popguide: false,
        friendonly: false,
        menutext: "",
        menulevel: -1,
        menu: false,
        totime: new Date().setSeconds(new Date().getSeconds() + 1000),
        tcnt: 0
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        // 倒计时
        timer: function timer() {
            if (this.ban > 0) {
                this.ban--;
            }

            if (this.status > 0) {
                this.setTimeText();
            }

            if (this.tcnt < 30) {
                this.tcnt++;
            } else {
                this.tcnt = 0;
                getInfo();
            }

            setTimeout(this.timer, 1000);
        },
        setTimeText: function setTimeText() {
            if (this.totime > new Date()) {
                var allmsec = this.totime - new Date();
                var day = parseInt(allmsec / (24 * 3600 * 1000));
                var hour = parseInt(
                    (allmsec - day * (24 * 3600 * 1000)) / (3600 * 1000)
                );
                var mi = parseInt(
                    (allmsec - day * (24 * 3600 * 1000) - hour * (3600 * 1000)) /
                    (60 * 1000)
                );
                var sec = parseInt(
                    (allmsec -
                        day * (24 * 3600 * 1000) -
                        hour * (3600 * 1000) -
                        mi * 60 * 1000 +
                        500) /
                    1000
                );
                this.timeText =
                    "" +
                    day +
                    "天" +
                    (hour < 10 ? "0" + hour : "" + hour) +
                    ":" +
                    (mi < 10 ? "0" + mi : "" + mi) +
                    ":" +
                    (sec < 10 ? "0" + sec : "" + sec);
            } else {
                this.timeText = "0天00:00:00"; //getInfo();

                setTimeout(getInfo(), 500);
            }
        },
        tapLevel: function tapLevel(item) {
            if (item.Level > app.userlevel) return;
            this.menulevel = item.Level;
            this.menutext = item.Name;
            this.menu = false;
        },
        join: function join() {
            if (app.ban > 0) {
                MsgBox("提示", "当前禁言中，剩余禁言时长：" + app.ban + "秒");
                return;
            }
            JavaScriptInterface.nativeCommand('setValue', '{\"key\":\"MFO\",\"value\":\"' + (app.friendonly ? "true" : "") + '\"}');
            window.location.href = "pair.html?idx=" + idx + "&level=" + app.menulevel + "&t=" + new Date().getTime();
        },
        toguide: function toguide() {
            SetValue("Guide" + idx, "T");
            if (this.guideurl.indexOf("?") > 0)
                window.location.href = this.guideurl + "&idx=" + idx;
            else if (this.guideurl.length > 0)
                window.location.href = this.guideurl + "?idx=" + idx;
        },
        totraiining: function totraiining() {
            if (this.trainingurl.indexOf("?") > 0)
                window.location.href = this.trainingurl + "&idx=" + idx;
            else if (this.trainingurl.length > 0)
                window.location.href = this.trainingurl + "?idx=" + idx;
        },
        tohelp: function tohelp() {
            SetValue("Help" + idx, "T");
            window.location.href = this.helpurl; // + "?idx=" + idx;
        },
        torule: function torule() {
            window.location.href = this.ruleurl;
        },
    },
    created: function created() {
    },
    mounted: function mounted() {
        // this.step = 1
        this.timer();
    }
});
var idx = GetQueryString("idx");

// 为1时，表示排队等待切后台，自动退出返回此页面，需要显示提示信息
var isBack = GetQueryString("back");
var initOptions = false;

function initInfo(msg) {
    switch (msg.code) {
        case 607:
        case "607":
        case "607.0":
            window.location.href = msg.info.url;
            break;

        case 606:
        case "606":
        case "606.0":
            MsgBox("提示", "正在其它比赛中，无法进入！", 3);
            setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
            break;
    }

    app.status = msg.info.status;
    app.ban = msg.info.ban;
    app.title = msg.info.title;
    app.helpurl = msg.info.helpurl;
    app.guideurl = msg.info.guideurl;
    app.trainingurl = msg.info.trainingurl;
    app.ruleurl = msg.info.ruleurl;
    app.gametype = msg.info.gametype;
    SetTitle(app.title);

    if (app.status > 0) {
        app.popguide = msg.info.popguide;

        if (app.popguide) {
            app.toguide();
        }

        if (app.guideurl.length == 0 && app.helpurl.length > 0) {
            GetValue("Help" + idx); //app.pophelp = true;
            // 获取缓存，如果没有打开过
            //app.tohelp();
        }

        if (msg.info.userlevel != null)
            app.userlevel = msg.info.userlevel;
        else
            app.userlevel = 0;
        if (msg.info.levels == null)
            app.levels = [];
        else
            app.levels = msg.info.levels;

        if (app.status == 1) {
            app.totime = new Date(msg.info.start);
            app.totime.setTime(
                app.totime.getTime() + (new Date() - new Date(msg.info.systime))
            );
        } else {
            app.totime = new Date(msg.info.end);
            app.totime.setTime(
                app.totime.getTime() + (new Date() - new Date(msg.info.systime))
            );
        }

        if (app.menulevel < 0) {
            app.menulevel = app.userlevel;
            app.levels.forEach(function (value, i) {
                if (value.Level == app.menulevel) {
                    app.menutext = value.Name;
                }
            });
        }
    }

    app.setTimeText(); //window.location.href = "six.html";
}

function getInfo() {
    if (app.part == 0) {
        app.part = 3;
    }

    getGameInfo();
}

function getGameInfo() {
    if (isSimulation) {
        console.log("getGameInfo");
        var jMsg = sim.gameinfo4;
        var msg = eval("(" + jMsg + ")");
        initInfo(msg);
    } else {
        if (idx <= 0) {
            JavaScriptInterface.nativeCommand("exit", "");
        }
        else {
            requestServer("Game/GetGameInfoByIdx", "idx=" + idx);
        }
    }
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case "server":
            initInfo(msg);
            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand("exit", ""); //window.location.href = "my.html";
                    //MsgBox("提示", "比赛进行中，无法退出！");

                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;

                case 233:
                case '233':
                case '233.0':
                    if (isBack == 1) {
                        isBack = 0;
                        MsgBox("提示", "APP刚才被切到后台了，需要重新进入", 5);
                    }
                    break;

                case 237:
                case "237":
                case "237.0":
                    //MsgBox("提示", msg.info);
                    if (msg.info == "Help" + idx + "_") {
                        app.tohelp();
                    }

                    break;

                default:
                    break;
            }
    }
}
