﻿$(document).ready(function () {
    JavaScriptInterface.nativeCommand('getToken', '');
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"个人雷达图\"}');

    var clientWidth = document.documentElement.clientWidth || window.innerWidth;
    var width = clientWidth - 20;
    var height = width - 80;
    $("#chart").css("height", height + "px");
    initChart();
});


function getUserAbility() {
    requestServer("User/GetUserAbility");
}

var myChart = {};
function initChart() {
    // 基于准备好的dom，初始化echarts图表
    myChart = echarts.init(document.getElementById('chart'));

    var option = {
        title: {
            text: ''    //能力值
        },
        tooltip: {
            trigger: 'axis'
        },
        //legend: {
        //    orient: 'vertical',
        //    x: 'right',
        //    y: 'bottom',
        //    data: ['能力值']
        //},
        toolbox: {
            show: false,
            feature: {
                mark: { show: true },
                dataView: { show: true, readOnly: false },
                restore: { show: true },
                saveAsImage: { show: true }
            }
        },
        polar: [
            {
                indicator: [
                    { text: '情绪表现力', max: 5.0 },
                    { text: '情绪解读力', max: 5.0 },
                    { text: '表达能力', max: 5.0 },
                    { text: '理解能力', max: 5.0 }
                ]
            }
        ],
        calculable: true,
        series: [
            {
                name: '能力值',
                type: 'radar',
                data: [
                    {
                        value: [],
                        name: '能力值'
                    }
                ]
            }
        ]
    };

    // 为echarts对象加载数据
    myChart.setOption(option);
}

function setChartInfo(msg) {
    myChart.setOption({
        series: [{
            name: '能力值',
            type: 'radar',
            data: [
                {
                    value: msg.info.ability,
                    name: '能力值'
                }
            ]
        }]
    });
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                setChartInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    window.location.href = "my.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getUserAbility();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}