Vue.use(VueAwesomeSwiper)
let app = new Vue({
    el: `#app`,
    data: {
        init: false,
        style: '',
        swiperOption: {
            navigation: {
                nextEl: '.swiper-button-next',
                prevEl: '.swiper-button-prev'
            }
        },
        activeIndex: 0,
        slideInfo: [],
        items: []
    },
    components: {
        LocalSwiper: VueAwesomeSwiper.swiper,
        LocalSlide: VueAwesomeSwiper.swiperSlide,
    },
    watch: {

    },

    beforeMount() {
        // 获取数据
        this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight
        this.style = `min-height: ${this.height}px`
    },

    computed: {
        swiper() {
            return this.$refs.awesomeSwiper.swiper
        }
    },
    methods: {
        tap() {
            console.log('tap')
        },
        onSetTranslate() {
            this.activeIndex = this.swiper.activeIndex
            setTitle(this.slideInfo[this.activeIndex].type)
            //        this.activeIndex = this.$refs.awesomeSwiper.swiper.activeIndex
            //       console.log('onSetTranslate')
        }

    },
    created() {
        myVue = this;
    },
    mounted() {
        this.init = true

    }
})

function setTitle(title) {
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜-' + title + '\"}');
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.newrank;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜\"}');
        requestServer("Exam/GetRanks");
    }
}

function showInfo(msg) {
    myVue.slideInfo = new Array();
    myVue.items = new Array();
    for (var i = 0; i < msg.info.rankinfos.length; i++) {
        myVue.slideInfo[i] = new Object();
        myVue.slideInfo[i].type = msg.info.rankinfos[i].gamename;
        myVue.slideInfo[i].myName = msg.info.rankinfos[i].me.nickname;
        myVue.slideInfo[i].myRank = msg.info.rankinfos[i].me.rank;
        myVue.slideInfo[i].myLevel = msg.info.rankinfos[i].me.level;
        myVue.items[i] = new Array();
        for (var j = 0; j < msg.info.rankinfos[i].tops.length; j++) {
            myVue.items[i][j] = new Object();
            myVue.items[i][j].label = msg.info.rankinfos[i].tops[j].nickname;
            myVue.items[i][j].value = msg.info.rankinfos[i].tops[j].level;
        }
    }
    setTitle(app.slideInfo[app.activeIndex].type);
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetRanks':
                    showInfo(msg);

                    break;
            }
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                default:
                    break;
            }
            break;
    }
}

