﻿"use strict";
var myVue = {};
Vue.use(VueAwesomeSwiper);
var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        swiperOption: {
            navigation: {
                nextEl: ".swiper-button-next",
                prevEl: ".swiper-button-prev"
            }
        },
        activeIndex: 0,
        slideInfo: [],
        items: []
    },
    components: {
        LocalSwiper: VueAwesomeSwiper.swiper,
        LocalSlide: VueAwesomeSwiper.swiperSlide
    },
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {
        swiper: function swiper() {
            return this.$refs.awesomeSwiper.swiper;
        }
    },
    methods: {
        tap: function tap() {
            console.log("tap");
        },
        onSetTranslate: function onSetTranslate() {
            this.activeIndex = this.swiper.activeIndex;
            setTitle(this.slideInfo[this.activeIndex].type); //        this.activeIndex = this.$refs.awesomeSwiper.swiper.activeIndex
            //       console.log('onSetTranslate')
        }
    },
    created: function created() {
        myVue = this;
    },
    mounted: function mounted() {
        this.init = true;
    }
});


function setTitle(title) {
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜-' + title + '\"}');
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.newrank;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜\"}');
        requestServer("Exam/GetRanks");
    }
}

function showInfo(msg) {
    myVue.slideInfo = new Array();
    myVue.items = new Array();
    for (var i = 0; i < msg.info.rankinfos.length; i++) {
        if (msg.info.rankinfos[i].gamecode == "PS2C") {
            myVue.slideInfo[0] = new Object();
            myVue.slideInfo[0].type = msg.info.rankinfos[i].gamename;
            myVue.slideInfo[0].myName = msg.info.rankinfos[i].me.nickname;
            myVue.slideInfo[0].myRank = msg.info.rankinfos[i].me.rank;
            myVue.slideInfo[0].myLevel = msg.info.rankinfos[i].me.level;
            myVue.items[0] = new Array();
            for (var j = 0; j < msg.info.rankinfos[i].tops.length; j++) {
                myVue.items[0][j] = new Object();
                myVue.items[0][j].label = msg.info.rankinfos[i].tops[j].nickname;
                myVue.items[0][j].value = msg.info.rankinfos[i].tops[j].level;
                myVue.items[0][j].remark = msg.info.rankinfos[i].tops[j].remark == null ? "" :
                    ("（" + msg.info.rankinfos[i].tops[j].remark + "）");
            }

            break;
        }
    }
    setTitle("沟通挑战赛");
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetRanks':
                    showInfo(msg);

                    break;
            }
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                default:
                    break;
            }
            break;
    }
}

