﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        audio: null,
        showticket: 1,
        showmsg: 0,
        upgrade: 0,
        tickets: 0,
        stars: 0,
        cstars: '',
        currexp: 0,
        totalexp: 100,
        exp: 0,
        menuidx: 0,
        level: 0,
        applyed: false,
        usedticket: false,
        store: false,
        popupClass: "popup",
        upgradeClass: "popup-body",
        text: [
            "",
            "",
            "",
            ""
        ],
        relationship: -1,
        gametype: -1,
        otheridx: 0,
        gamedata: {
            matchidx: 0,
            label: "",
            time: "",
            roundcount: 1,
            score: 0,
            score1: 0,
            score2: 0,
            scoreinfo: "",
            child: [
                {
                    label: "",
                    value: ""
                },
                {
                    label: "",
                    value: ""
                }
            ]
        }
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
        this.audio = document.createElement("audio");
        this.audio.src = "./sound/click.mp3";
    },
    computed: {
        friendtext: function friendtext() {
            if (this.gametype > 0)
                return "";
            //applyed || relationship==1
            if (this.applyed) {
                if (this.relationship == 1) {
                    return "你们是好友了";
                } else {
                    return "对方确认后成为好友\n（到“我的-好友”中查看结果）";
                }
            }
            else {
                if (this.relationship == 1) {
                    return "好友相逢，好缘份！";
                } else {
                    return "对方确认后成为好友\n（到“我的-好友”中查看结果）";
                }
            }

            return "";
        }
    },
    methods: {
        tap: function tap() {
            this.showDetail = !this.showDetail;
        },
        tapPopup: function tapPopup() {
            this.showmsg = !this.showmsg;
            this.popupClass = this.showmsg == 1 ? "popup active" : "popup";
        },
        showalert: function showalert() {
            var that = this; //this.init = true

            if (that.store && that.showmsg == 1) {
                setTimeout(function (argument) {
                    that.popupClass = "popup active";
                    that.audio.play();
                }, 300);
                if (that.upgrade == 1) {
                    setTimeout(function (argument) {
                        that.upgradeClass = "popup-body animate";
                    }, 500);
                }
                else {
                    that.upgradeClass = "popup-body active";
                }
            }
        },
        tapUse: function tapUse() {
            //this.popupClass = "popup";
            //this.upgradeClass = "popup-body";
            if (this.tickets > 0) {
                this.usedticket = true;
                UseDblTicket();
                //this.showalert();
            }
        },
        tapGo: function tapGo() {
            window.location.href = "../game/pair.html?idx=" + this.menuidx + "&level=" + this.level;
        },
        gotoStore: function gotoStore() {
            JavaScriptInterface.nativeCommand('gotoStore', '');
            // 调用api接口通知服务器TODO
            AppStore();
            //this.tapPopup();
        },
        tapApply: function tapApply() {
            ApplyFriend();
        },
        showDetail: function showDetail(round) {
            var url = "Review.html?matchidx=" + app.gamedata.matchidx + "&round=" + round;
            //MsgBox("url", url);
            window.location.href = url;
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
        this.showalert();
    }
});

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.ps2result3;
        var msg = { "info": null };
        msg = eval("(" + jMsg + ")");
        showInfo(msg);
    } else {
        JavaScriptInterface.nativeCommand("setTitle", '{"title":"成绩报告"}');
        requestServer("GamePS2/GetResult");
    }
}

function GetRelationship() {
    if (isSimulation) {
        var jMsg = sim.relationship;
        var msg = eval("(" + jMsg + ")");
        afterGetRelationship(msg);
    } else {
        requestServer("Friend/Relationship", "touser=" + app.otheridx);
    }
}

function afterGetRelationship(msg) {
    app.relationship = msg.info.r;
}

function ApplyFriend() {
    app.applyed = true;
    app.relationship = -1;
    if (isSimulation) {
        var jMsg = sim.applyfriend;
        var msg = eval("(" + jMsg + ")");
        afterApplyFriend(msg);
    } else {
        requestServer("Friend/Apply", "touser=" + app.otheridx);
    }
}
function afterApplyFriend(msg) {
    app.relationship = msg.info.r;
}

function UseDblTicket() {
    if (isSimulation) {
        var jMsg = sim.usedblticket;
        var msg = eval("(" + jMsg + ")");
        afterUseTicket(msg);
    } else {
        requestServer("Game/UseDblTicket");
    }
}

function AppStore() {
    if (isSimulation) {
        var jMsg = sim.appstore;
        var msg = eval("(" + jMsg + ")");
        afterAppStrore(msg);
    } else {
        requestServer("Game/GotoAppStore");
    }
}

function afterAppStrore(msg) {
    app.tickets = msg.info.tickets;
    setTimeout(app.tapPopup, 1000)
    //app.showmsg = 0;
    //app.popupClass = "popup";
}

function afterUseTicket(msg) {
    SetShowMsg(msg);
}

function showInfo(msg) {
    app.gamedata.matchidx = msg.info.matchidx;
    app.gamedata.score = msg.info.score1 + msg.info.score2;
    app.gamedata.score1 = msg.info.score1;
    app.gamedata.score2 = msg.info.score2;
    //app.gamedata.scoreinfo = msg.info.score1 + " + " + msg.info.score2;
    app.gamedata.label = msg.info.user1 + " & " + msg.info.user2;
    app.gamedata.time = msg.info.finishtime;
    app.gamedata.roundcount = msg.info.roundcount;
    var child = [];
    app.menuidx = msg.info.menuidx;
    app.level = msg.info.level;
    app.gametype = msg.info.gametype;
    app.otheridx = msg.info.otheridx;
    if (msg.info.gametype == 0)
        GetRelationship();

    app.gamedata.child = child;
    if (msg.info.gametype == 3)
        SetShowMsg(msg);
}

function SetShowMsg(msg) {
    //app.showmsg = msg.info.showmsg;
    app.upgrade = msg.info.msginfo.upgrade;
    app.stars = msg.info.msginfo.stars;
    app.tickets = msg.info.msginfo.tickets;
    app.text = msg.info.msginfo.details.split("|");

    app.exp = msg.info.msginfo.exp;
    app.currexp = msg.info.examinfo.point;
    app.totalexp = msg.info.examinfo.total;
    app.store = msg.info.msginfo.store;
    app.showticket = msg.info.showticket;
    var cstars = '';
    for (var i = 0; i < msg.info.examinfo.star; i++) {
        cstars += '★';
    }
    app.cstars = cstars;

    app.store = msg.info.msginfo.store;

    if (app.upgrade == 1) {
        if (msg.info.msginfo.stars == 3) {
            app.level = 1;
        }
        else if (msg.info.msginfo.stars == 4) {
            app.level = 2;
            app.showmsg = 1;
        }
        else if (msg.info.msginfo.stars == 5) {
            app.showmsg = 1;
        }
    }
    app.showalert();

} // JavaScript source code

function onGameNativeMsg(source, msg) {
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetResult") showInfo(msg);
                else if (msg.request == "UseDblTicket") afterUseTicket(msg);
                else if (msg.request == "GotoAppStore") afterAppStrore(msg);
                else if (msg.request == "Relationship") afterGetRelationship(msg);
                else if (msg.request == "Apply") afterApplyFriend(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand("exit", ""); //window.location.href = "my.html";

                    break;
                case 238:
                    MsgBox('测试', '应用商店返回');


                    break;
                default:
                    break;
            }
    }
}
