﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        audio: null,
        showmsg: 0,
        upgrade: 0,
        tickets: 0,
        stars: 0,
        popupClass: "popup",
        upgradeClass: "popup-body",
        text: [
            "",
            "",
            "",
            ""
        ],
        gamedata: {
            label: "",
            time: "",
            score: 0,
            scoreinfo: "",
            child: [
                {
                    label: "",
                    value: ""
                },
                {
                    label: "",
                    value: ""
                }
            ]
        }
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
        this.audio = document.createElement("audio");
        this.audio.src = "./sound/click.mp3";
    },
    computed: {},
    methods: {
        tap: function tap() {
            this.showDetail = !this.showDetail;
        },
        tapPopup: function tapPopup() {
            this.showmsg = !this.showmsg;
            this.popupClass = this.showmsg == 1 ? "popup active" : "popup";
        },
        showalert: function showalert() {
            var that = this; //this.init = true

            if (that.showmsg == 1) {
                setTimeout(function (argument) {
                    that.popupClass = "popup active";
                    that.audio.play();
                }, 300);
                if (that.upgrade == 1) {
                    setTimeout(function (argument) {
                        that.upgradeClass = "popup-body animate";
                    }, 500);
                }
                else {
                    that.upgradeClass = "popup-body active";
                }

            }


        },
        tapUse: function tapUse() {
            this.popupClass = "popup";
            this.upgradeClass = "popup-body";
            UseDblTicket();
            this.showalert();
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
        this.showalert();
    }
});

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.ps2result;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    } else {
        JavaScriptInterface.nativeCommand("setTitle", '{"title":"成绩报告"}');
        requestServer("GamePS2/GetResult");
    }
}

function UseDblTicket() {
    if (isSimulation) {
        var jMsg = sim.usedblticket;
        var msg = eval("(" + jMsg + ")");
        afterUseTicket(msg);
    } else {
        requestServer("Game/UseDblTicket");
    }
}

function afterUseTicket(msg) {
    SetShowMsg(msg);
}

function showInfo(msg) {
    if(msg.info.matchstatus>1)
    	app.gamedata.score = msg.info.score1 + msg.info.score2;
    else
	app.gamedata.score = "---";

    app.gamedata.scoreinfo = msg.info.score1 + " + " + msg.info.score2;
    app.gamedata.label = msg.info.user1 + " & " + msg.info.user2;
    app.gamedata.time = msg.info.finishtime;
    var child = [];

    if (msg.info.records[0].score >= 5000 && msg.info.records[0].users != undefined) {
        child.push({
            label: "第一题：",
            value:
                msg.info.records[0].score +
                " " +
                msg.info.records[0].users[0] +
                " & " +
                msg.info.records[0].users[1]
        });
    } else {
        child.push({
            label: "第一题：",
            value: "（无记录）"
        });
    }

    if (msg.info.records[1].score >= 5000 && msg.info.records[1].users != undefined) {
        child.push({
            label: "第二题：",
            value:
                msg.info.records[1].score +
                " " +
                msg.info.records[1].users[0] +
                " & " +
                msg.info.records[1].users[1]
        });
    } else {
        child.push({
            label: "第二题：",
            value: "（无记录）"
        });
    }

    app.gamedata.child = child;
    SetShowMsg(msg);
    app.showalert();
}

function SetShowMsg(msg) {
    app.showmsg = msg.info.showmsg;

    if (app.showmsg == 1) {
        app.upgrade = msg.info.msginfo.upgrade;
        app.stars = msg.info.msginfo.stars;
        app.tickets = msg.info.msginfo.tickets;
        app.text = msg.info.msginfo.details.split("|");
    }
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetResult") showInfo(msg);
                else if (msg.request == "UseDblTicket") afterUseTicket(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand("exit", ""); //window.location.href = "my.html";

                    break;

                default:
                    break;
            }
    }
}
