﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        menuidx: 0,
        showtype: 5,
        style: "",
        showmsg: 0,
        upgrade: 0,
        tickets: 0,
        stars: 0,
        popupClass: "popup",
        upgradeClass: "popup-body",
        text: ["", "", "", ""],
        role: "",
        likerole: "",
        satisfied: 0,
        rank: 2,
        scorematch: 20,
        scorerank: 30,
        scoretotal: 50,
        roles: [
            {
                role: "B",
                title: "张三"
            },
            {
                role: "C",
                title: "华山一条路"
            },
            {
                role: "D",
                title: "王五"
            }
        ]
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        //initinfo(items, array, avgscore, beyondcount, allcount) {
        //    this.score = avgscore * 1.0 / 100
        //    var pre = (beyondcount * 100 / allcount).toFixed(0)
        //    this.ratio = `${pre}%`
        //    this.items = items
        //    this.array = array
        //},
        tapSatis: function tapSatis(result) {
            console.log(result);
            this.satisfied = result;
            console.log(this.satisfied);
            submitSurvey(); //this.showtype = 3;
            //this.showtype = 2;
        },
        tapRole: function tapRole(idx) {
            console.log(idx);
            this.likerole = this.roles[idx].role;
            console.log(this.likerole);
            this.showtype = 2;
            var title = "面试 - 对面试官的反馈";
            SetTitle(title);
        },
        tapPopup: function tapPopup() {
            this.showmsg = !this.showmsg;
            this.popupClass = this.showmsg == 1 ? "popup active" : "popup";
        },
        showalert: function showalert() {
            var that = this; //this.init = true

            if (that.showmsg == 1) {
                setTimeout(function (argument) {
                    that.popupClass = "popup active";
                    that.audio.play();
                }, 500);
                setTimeout(function (argument) {
                    that.upgradeClass =
                        that.upgrade == 1 ? "popup-body animate" : "popup-body active";
                }, 1000);
            }
        },
        tapUse: function tapUse() {
            this.popupClass = "popup";
            this.upgradeClass = "popup-body";
            UseDblTicket();
            this.showalert();
        },
        tap: function tap() {
            //this.showDetail = !this.showDetail
        },
        share: function share() {
            alert("分享");
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});

function initInfo(msg) {
    var matchIdx = msg.info.matchidx;
    app.menuidx = msg.info.menuidx;

    if (!leave) {
        leaveRoom(matchIdx);
    }

    var title = "";

    if (msg.info.status == 1) {
        title = "面试 - 选择同事";
        app.showtype = 1;
        app.roles.splice(0, app.roles.length);

        for (var i = 0; i < msg.info.roles.length; i++) {
            var r = {};
            r.role = msg.info.roles[i].slice(0, 1);
            r.title = msg.info.roles[i].slice(1);
            app.roles.push(r);
        }
    } else if (msg.info.status == 2) {
        title = "面试 - 成绩";
        app.showtype = 3;
        app.scorerank = msg.info.scorer;
        app.scorematch = msg.info.scorem;
        app.scoretotal = msg.info.scoret;
        app.rank = msg.info.rank;
        SetShowMsg(msg);
    } else {
        title = "面试 - 成绩";
        app.showtype = 4;
        app.scorematch = msg.info.scorem;
        app.scoretotal = msg.info.scoret;
        SetShowMsg(msg);
    }

    app.showalert();
    SetTitle(title);
}

function initMsg(msg) {
    SetShowMsg(msg);
    app.showalert();
}

function submitSurvey() {
    if (isSimulation) {
        alert(app.likerole + "_" + app.satisfied);
    } else {
        requestServer(
            "GamePA/Survey",
            "role=" + app.likerole + "&satisfied=" + app.satisfied
        );
    }
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.new4;
        var msg = eval("(" + jMsg + ")");
        initInfo(msg);
    } else {
        requestServer("GamePA/GetMatchStatusInfo");
    }
}

var leave = false;

function leaveRoom(roomName) {
    if (isSimulation) {
        leave = true;
    } else {
        JavaScriptInterface.nativeCommand(
            "leaveRoom",
            '{"name":"' + roomName + '"}'
        );
    }
}

function exit() {
    JavaScriptInterface.nativeCommand("msgBox", "exit");
}

function UseDblTicket() {
    if (isSimulation) {
        var jMsg = sim.usedblticket;
        var msg = eval("(" + jMsg + ")");
        afterUseTicket(msg);
    } else {
        requestServer("Game/UseDblTicket");
    }
}

function afterUseTicket(msg) {
    SetShowMsg(msg);
}

function SetShowMsg(msg) {
    app.showmsg = msg.info.showmsg;

    if (app.showmsg == 1) {
        app.upgrade = msg.info.msginfo.upgrade;
        app.stars = msg.info.msginfo.stars;
        app.tickets = msg.info.msginfo.tickets;
        app.text = msg.info.msginfo.details.split("|");
    }
} // JavaScript source code
// JavaScript source code

function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "UseDblTicket") {
                    initMsg(msg);
                } else initInfo(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    if (app.menuidx > 0)
                        window.location.href = "../game/portal.html?idx=" + app.menuidx;
                    else
                        JavaScriptInterface.nativeCommand("exit", "");
                    //MsgBox('提示', '比赛进行中，无法退出！');

                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;

                case 225:
                case "225":
                case "225.0":
                    break;

                case 230:
                case "230":
                case "230.0":
                    leave = true;
                    break;

                default:
                    break;
            }
    }
}
