﻿let app = new Vue({
    el: `#app`,
    data: {
        init: false,
        score: 7.63,
        ratio: '20%',
        showDetail: false,
        style: '',
        items: [
            {
                label: '说服力得分',
                subtitle: '',
                subtitle2: '',
                score: 8.3,
                order: 1
            },
            {
                label: '判断力得分',
                score: 7.0,
                order: 2
            },
            {
                label: '综合得分',
                score: 7.4,
                order: 3
            }
        ],
        array: [
            {
                label: '说服力得分',
                score: 7.4,
                child: [
                    {
                        ord: 1,
                        title: 'A.限行',
                        score: 9.32
                    },
                    {
                        ord: 1,
                        title: 'C.限行',
                        score: 8.23
                    },
                    {
                        ord: 1,
                        title: 'D.限行',
                        score: 4.55
                    },
                    {
                        ord: 1,
                        title: 'D.拍牌',
                        score: 3.25
                    },
                    {
                        ord: 1,
                        title: 'C.拥堵费',
                        score: 2.50
                    }
                ]
            },
            {
                label: '判断力得分',
                score: 7.5,
                child: [
                    {
                        ord: 1,
                        title: 'A.限行',
                        user: 'A.限行'
                    },
                    {
                        ord: 1,
                        title: 'C.拥堵费',
                        user: 'C.拥堵费'
                    },
                    {
                        ord: 1,
                        title: 'D.限行',
                        user: 'D.拍牌'
                    },
                    {
                        ord: 1,
                        title: 'D.拍牌',
                        user: 'D.拍牌'
                    }
                ]
            },
            {
                label: '综合得分',
                score: 7.6,
                child: [
                    {
                        ord: 1,
                        title: 'A.限行'
                    },
                    {
                        ord: 1,
                        title: 'C.限行'
                    },
                    {
                        ord: 1,
                        title: 'D.限行'
                    },
                    {
                        ord: 1,
                        title: 'D.拍牌'
                    },
                    {
                        ord: 1,
                        title: 'C.拥堵费'
                    }
                ]
            }
        ]
    },
    components: {},
    watch: {

    },

    beforeMount() {
        // 获取数据
        this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight
        this.style = `min-height: ${this.height}px`
    },

    computed: {

    },
    methods: {
        initinfo(items, array, avgscore, beyondcount, allcount) {
            this.score = avgscore * 1.0 / 100
            var pre = (beyondcount * 100 / allcount).toFixed(0)
            this.ratio = `${pre}%`
            this.items = items
            this.array = array
        },
        tap() {
            this.showDetail = !this.showDetail
        },
        share() {
            alert('分享')
        }

    },
    created() {

    },
    mounted() {
        this.init = true
    }
})

function initInfo(msg) {
    var items = [];
    var array = [];
    var mutli = msg.info.reports.length > 1;
    var label = '';
    var subtitle = '小组排名';
    var jchild = [];
    var jarray = {};
    var jscore = 0;
    var mtitle = ['主动性', '感召力', '亲和力'];
    var titles = ['表述', '鹰眼', '理解'];

    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"成绩报告\"}');

    //var report = msg.info.reports[ranktype - 1];
    msg.info.reports.forEach(function (report, idx) {
        var achild = [];
        var jchild = [];
        var score = 0;
        var order = 1;
        var sn = 1;
        var s = 0;
        var ranktype = report.ranktype;

        if (idx == 0) {
            sn = 1;
            s = 0;
            label = '判断力得分';
            report.score.sort(sortj).forEach(function (value, i) {
                if (value.jscore == s) {
                    // 并列
                }
                else {
                    s = value.jscore;
                    sn = i + 1;
                }
                jchild.push({ ord: sn, title: value.role + '.' + value.title, score: value.jscore });
                if (value.role == msg.info.role) {
                    order = sn;
                    score = value.jscore;
                    jscore = score;
                }
            });
            items.push({ label: label, score: score, order: order });
            //items.splice(ranktype - 1, 0, { label: label, score: score, order: order });
            array.push({ label: label, score: score, subtitle: subtitle, child: jchild });

        }

        //label = '说服力得分';
        report.score.sort(sorta).forEach(function (value, i) {
            if (value.ascore == s) {
                // 并列
            }
            else {
                s = value.ascore;
                sn = i + 1;
            }
            achild.push({ ord: sn, title: value.role + '.' + value.title, score: value.ascore });
            if (value.role == msg.info.role) {
                order = sn;
                score = value.ascore;
            }
        });


        subtitle = '小组排名';
        if (ranktype > 0) {
            label = titles[ranktype - 1] + ' 得分';
            items.splice(ranktype - 1, 0, { label: label, score: score, order: order });
            array.splice(ranktype - 1, 0, { label: label, score: score, subtitle: subtitle, child: achild });
        }
        else {
            label = '综合得分'
            items.push({ label: label, score: score, order: order });
            array.push({ label: label, score: score, subtitle: subtitle, child: achild });
        }
    });
    app.initinfo(items, array, msg.info.avgscore, msg.info.beyondcount, msg.info.allcount);
    if (msg.info.exammsg.length > 0) {
        MsgBox("提示", msg.info.exammsg);
    }
}

function sorta(a, b) {
    return b.ascore - a.ascore;
}

function sortj(a, b) {
    return b.jscore - a.jscore;
}

function sortc(a, b) {
    return b.cscore - a.cscore;
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.appsix;
        var msg = eval("(" + jMsg + ")");
        initInfo(msg);
    }
    else {
        requestServer("GamePA/GetMatchStatusInfo");
    }
}

function exit() {
    JavaScriptInterface.nativeCommand('msgBox', 'exit');
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                //if (msg.request == "GetMatchStatusInfo")
                initInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.location.href = "my.html";
                    //MsgBox('提示', '比赛进行中，无法退出！');
                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;
                case 225:
                case '225':
                case '225.0':
                    break;
                case 230:
                case '230':
                case '230.0':
                    leave = true;
                    break;
                default:
                    break;
            }
    }
}