﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        menuidx: 0,
        audio: null,
        showDetail: false,
        showmsg: 0,
        upgrade: 0,
        tickets: 0,
        stars: 0,
        selfresult: 0,
        passivecount: 0,
        popupClass: "popup",
        upgradeClass: "popup-body",
        text: [
            "",
            "",
            "",
            ""
        ],
        summary: {
            label: "综合得分",
            score: 0,
            avgscore: 0,
            ratio: 0
        },
        array: [
            {
                label: "",
                score: 0,
                ord: 0,
                child: [
                    {
                        ord: 0,
                        title: "",
                        score: 0
                    }
                ]
            },
        ]
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
        this.audio = document.createElement("audio");
        this.audio.src = "./sound/click.mp3";
    },
    computed: {},
    methods: {
        tap: function tap() {
            this.showDetail = !this.showDetail;
        },
        quit: function quit() {
            JavaScriptInterface.nativeCommand("exit", "");
        },
        initinfo: function initinfo(summary, array) {
            this.summary = summary;
            //this.items = items;
            this.array = array;
        },
        tapPopup: function tapPopup() {
            this.showmsg = !this.showmsg;
            this.popupClass = this.showmsg == 1 ? "popup active" : "popup";
        },
        showalert: function showalert() {
            var that = this; //this.init = true

            if (that.showmsg == 1) {
                setTimeout(function (argument) {
                    that.popupClass = "popup active";
                    that.audio.play();
                }, 500);
            }

            setTimeout(function (argument) {
                that.upgradeClass =
                    that.upgrade == 1 ? "popup-body animate" : "popup-body active";
            }, 1000);
        },
        tapUse: function tapUse() {
            this.popupClass = "popup";
            this.upgradeClass = "popup-body";
            UseDblTicket();
            this.showalert();
        }
    },
    created: function created() { },
    mounted: function mounted() {
        var that = this;
        this.init = true;
        this.showalert();
    }
});

function initInfo(msg) {
    //var items = [];
    app.menuidx = msg.info.menuidx;
    var array = [];
    var sitems = [];
    var subtitle = "小组排名";
    var titlespa = ["陈述", "犀利", "懂我"];
    var titlespam = ["说服力", "积极", "亲和"];
    var matchscore = 0;
    //JavaScriptInterface.nativeCommand("setTitle", '{"title":"成绩报告"}'); //var report = msg.info.reports[ranktype - 1];
    SetTitle("成绩报告");
    msg.info.reports.forEach(function (report, idx) {
        var achild = [];
        var jchild = [];
        var label = "";
        var score = 0;
        var order = 1;
        var sn = 1;
        var s = 0;
        var ranktype = report.ranktype;

        if (idx == 0) {
            label = "判断力";
            report.score.sort(sortj).forEach(function (value, i) {
                if (value.jscore == s) {
                    // 并列
                } else {
                    s = value.jscore;
                    sn = i + 1;
                }

                jchild.push({
                    ord: sn,
                    title: value.role + "." + value.title,
                    score: value.jscore
                });

                if (value.role == msg.info.role) {
                    order = sn;
                    score = value.jscore;
                    //jscore = score;
                }
            });
            //items.push({
            //    label: label,
            //    score: score,
            //    order: order
            //});
            //items.splice(ranktype - 1, 0, { label: label, score: score, order: order });

            array.push({
                label: label,
                score: score,
                ord: order,
                subtitle: subtitle,
                child: jchild
            });

            report.score.sort(sortc).forEach(function (value, i) {
                if (value.cscore == s) {
                    // 并列
                } else {
                    s = value.cscore;
                    sn = i + 1;
                }

                achild.push({
                    ord: sn,
                    title: value.role + "." + value.title,
                    score: value.cscore
                });

                if (value.role == msg.info.role) {
                    order = sn;
                    score = value.cscore;
                }
            });
            subtitle = "小组排名";
        }
        else {
            report.score.sort(sorta).forEach(function (value, i) {
                if (value.ascore == s) {
                    // 并列
                } else {
                    s = value.ascore;
                    sn = i + 1;
                }

                achild.push({
                    ord: sn,
                    title: value.role + "." + value.title,
                    score: value.ascore
                });

                if (value.role == msg.info.role) {
                    order = sn;
                    score = value.ascore;
                }
            });
            subtitle = "小组排名";
        }
        //label = '说服力得分';


        if (ranktype > 0) {
            if (msg.info.gamecode == "PA")
                label = titlespa[ranktype - 1];
            else
                label = titlespam[ranktype - 1];
            //items.splice(ranktype - 1, 0, {
            //    label: label,
            //    score: score,
            //    order: order
            //});
            array.splice(ranktype - 1, 0, {
                label: label,
                score: score,
                ord: order,
                subtitle: subtitle,
                child: achild
            });
        } else {
            label = "综合";
            //items.push({
            //    label: label,
            //    score: score,
            //    order: order
            //});
            array.push({
                label: label,
                score: score,
                ord: order,
                subtitle: subtitle,
                child: achild
            });
            matchscore = score;
        }
    });
    //this.score = (avgscore * 1.0) / 100;
    var summary = {};
    summary.label = "综合得分";
    summary.avgscore = (msg.info.avgscore * 1.0) / 100;
    summary.score = matchscore;
    summary.ratio = ((msg.info.beyondcount * 100) / msg.info.allcount).toFixed(0);
    summary.items = sitems;
    app.initinfo(
        summary,
        //items,
        array
    );
    app.passivecount = msg.info.passivecount;
    app.selfresult = msg.info.selfresult;
    SetShowMsg(msg);
    app.showalert();
}

function sorta(a, b) {
    return b.ascore - a.ascore;
}

function sortj(a, b) {
    return b.jscore - a.jscore;
}

function sortc(a, b) {
    return b.cscore - a.cscore;
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.appsixp;
        var msg = eval("(" + jMsg + ")");
        initInfo(msg);
    } else {
        requestServer("GamePA/GetMatchStatusInfo");
    }
}

function exit() {
    JavaScriptInterface.nativeCommand("msgBox", "exit");
}

function UseDblTicket() {
    if (isSimulation) {
        var jMsg = sim.usedblticket;
        var msg = eval("(" + jMsg + ")");
        afterUseTicket(msg);
    } else {
        requestServer("Game/UseDblTicket");
    }
}

function afterUseTicket(msg) {
    SetShowMsg(msg);
}

function SetShowMsg(msg) {
    app.showmsg = msg.info.showmsg;

    if (app.showmsg == 1) {
        app.upgrade = msg.info.msginfo.upgrade;
        app.stars = msg.info.msginfo.stars;
        app.tickets = msg.info.msginfo.tickets;
        app.text = msg.info.msginfo.details.split("|");
    }
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetMatchStatusInfo")
                    initInfo(msg);
                else if (msg.request == "UseDblTicket")
                    afterUseTicket(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    if (app.menuidx > 0)
                        window.location.href = "../game/portal.html?idx=" + app.menuidx;
                    else
                        JavaScriptInterface.nativeCommand("exit", "");
                    //MsgBox('提示', '比赛进行中，无法退出！');

                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;

                case 225:
                case "225":
                case "225.0":
                    break;

                case 230:
                case "230":
                case "230.0":
                    leave = true;
                    break;

                default:
                    break;
            }
    }
}
