﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        status: 1,
        gamecode: "ps2s",
        examcount: "",
        usercount: "",
        avgscore: "0",
        maxscore: "0",
        starname: null,
        starscore: "-",
        staraward: 0,
        nkname: null,
        nkscore: -1,
        nkaward: 0,
        userscore: "-",
        hasnk: 1,
        gamename: ""
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {},
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});



function getInfo() {
    if (isSimulation) {
        var jMsg = sim.todaystar;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        requestServer("Exam/GetUserExamToday");
    }
}

function getName(code) {
    switch (code.toUpperCase()) {
        case 'PS2S': return '沟通成本';
        case 'PS2C': return '说人话';
        case 'PA': return '有效说服';
        case 'PAM': return '面试沟通';
    }
    return code;
}

function showInfo(msg) {
    var title = "今日战况";
    if (msg.info.status == 2) title = "今日战况（进行中）";
    if (msg.info.status == 3) title = "今日战况（最终）";
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"' + title + '\"}');

    app.status = msg.info.status;
    app.gamecode = msg.info.gamecode;
    app.gamename = getName(app.gamecode);
    app.usercount = msg.info.usercount;
    app.examcount = msg.info.examcount;

    app.avgscore = msg.info.avgscore;
    app.maxscore = msg.info.maxscore;
    app.starname = msg.info.starname;
    app.starscore = msg.info.starscore;
    app.staraward = msg.info.staraward;
    app.nkname = msg.info.nkname;
    app.nkscore = msg.info.nkscore;
    app.nkaward = msg.info.nkaward;

    app.hasnk = msg.info.hasnk;
    app.userscore = msg.info.userscore;
}


// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetUserExamToday':
                    showInfo(msg);

                    break;
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    break;
                case 223:
                case '223':
                case '223.0':
                    break;
                default:
                    break;
            }
    }
}