﻿/*
 * Game PS version 3.06 (May 5, 2019)
 */

var debug = false;

var base = "api/";
var apiCode = "GamePS2";
var gameName = "提示";
var mainPage = "board-page";
var currentMsg;
var initMsg = null;
var finishMsg = null;
var lastMoveMsg = null;
var resendCount;
var targetbackground_i = 0;

//to be packaged into a structure exposed to external module
var points = 10000;
var opcount = 0;
var startTime = 0;
var totalTime = 0;

//Level options, see onInit for details
var backgroundOption = 0;
var blockShowOption = 0;
var blockMoveOption = 0;
//var voiceOption = 0;			//0 - duplex, 1 - simplex

var focusBlock = null;
var blockBeingRotated = null;  // The DOM image currently being rotated (if any)
var blockBeingTranslated = null;  // The DOM image currently being translated (if any)
var mouseStartAngle = false;    // The angle of the mouse relative to the image centre at the start of the rotation
var mouseStartX = false;
var mouseStartY = false;
//var toolBeingSized = null;

var DegPerGrid;
var RadPerGrid;
var maxzindex = 10;
var deadzindex = 5;
//var textPoints;

var countdown = 12;
var step = 0;
var lastX, lastY;
var lastAngle = 0;
var currentTime, thinkTime, moveTime, currentAction, commentIdx;

var titleHeight, starHeight;

var timerRightPos;
var rightPositionDisplayed = false;

var workBoard, targetBoard;
var isLargeTargetBoard = false;
var currentBG = 0;
var currentBackgroundFile, correctBackgroundFile;

var nextGame;

var currentStar = 0;

var DIA_LOOK = 100;
var iLook = 1;

//var oldMsg = null;
//var tellerQuitReasons = ["看不到也听不到对方的反馈"];
//var listenerQuitReasons = ["完全听不到对方声音","听不清对方声音","物件无法移动","物件始终移不到位"];

var inaction = false; //当前板块处于操作状态

//only for test simulation

var targetBoard;
var workBoard;

var protoBoard = {
    init: function () {

        document.oncontextmenu = function () { return false }
        document.onselectstart = function () { return false }
        document.ondragstart = function () { return false }

        //		document.ontouchmove = function(e){ e.stopPropagation(); e.preventDefault(); };
    },
    setBounds: function (divId, left, top, width, height, grids) {
        this.boardDiv = document.getElementById(divId);
        this.boardDiv.style.left = left + 'px';
        this.boardDiv.style.top = top + 'px';
        this.boardDiv.style.width = width + 'px';
        this.boardDiv.style.height = height + 'px';
        this.gridSize = width / grids;
        this.ra2 = 0.013 * screenWidth * screenWidth;			//r*r of the inner circle of the rotation ring
        this.rb2 = 0.04 * screenWidth * screenWidth;			//r*r of the outer circle of the rotation ring
        this.rc2 = 0.09 * screenWidth * screenWidth;			//r*r of the containing circle of external move handles
        this.gScale = 1.0;

        if (this.flag == 'movable') {
            //			boardDiv.addEventListener("touchstart", root.onClientMouseMove, true);
            this.boardDiv.addEventListener("touchmove", protoBoard.onClientMouseMove, true);
            this.boardDiv.addEventListener("touchend", protoBoard.onClientMouseUp, true);
            this.boardDiv.addEventListener("mousemove", protoBoard.onClientMouseMove, true);
            this.boardDiv.addEventListener("mouseup", protoBoard.onClientMouseUp, true);
        }
    },
    getBounds: function () {
        //		var rect = this.boardDiv.getBoundingClientRect();
        var rect = new Object();
        rect.left = parseInt(this.boardDiv.style.left);
        rect.top = parseInt(this.boardDiv.style.top);
        rect.width = parseInt(this.boardDiv.style.width);
        rect.height = parseInt(this.boardDiv.style.height);
        return rect;
    },
    resizeBounds: function (rect) {
        this.gScale = this.gScale * rect.width / parseInt(this.boardDiv.style.width);

        this.boardDiv.style.left = rect.left + "px";
        this.boardDiv.style.top = rect.top + "px";
        this.boardDiv.style.width = rect.width + "px";
        this.boardDiv.style.height = rect.height + "px";

        //assume that the scale at the x axis is same as the scale at the y axis
        //		this.gridSize = this.gridSize*gScale;

        for (var x in this.boardDiv.childNodes) {
            //undefined means non "shape" object, such as the prompt div
            if (this.boardDiv.childNodes[x].father != undefined) {
                var obj = this.boardDiv.childNodes[x].father;
                //				obj.translateX = obj.translateX**this.gScale;
                //				var xc = this.gScale*obj.width*this.gridSize/2;
                //				var yc = this.gScale*obj.height*this.gridSize/2;
                //				obj.div.style.transformOrigin = xc + "px " + yc + "px";  
                //				obj.div.style.msTransformOrigin = xc + "px " + yc + "px"; 
                //				obj.div.style.MozTransformOrigin = xc + "px " + yc + "px"; 
                //				obj.div.style.webkitTransformOrigin = xc + "px " + yc + "px";   
                //				obj.div.style.OTransformOrigin = xc + "px " + yc + "px"; 
                transformBlock(obj.div, obj.translateX, obj.translateY, obj.rotateAngle);
            }
        }
    },
    setBackground: function (url) {
        this.boardDiv.style.backgroundImage = 'url(' + url + ')';
    },
    setFilter: function (filter) {
        //		this.boardDiv.style.backdropFilter = filter;
        //		this.boardDiv.style.background = "filter(" + this.boardDiv.style.backgroundImage + ",'" + filter + "')";
    },
    createBlock: function (type, id, width, height, touchable) {
        var z = new Block(type, width, height);
        z.id = id;
        z.board = this;
        z.init(touchable);
        this.boardDiv.appendChild(z.div);
        this.appList[id] = z;
        return z;
    },
    findBlock: function (id) {
        for (var x in this.boardDiv.childNodes) {
            //undefined means non "shape" object, such as the prompt div
            if (this.boardDiv.childNodes[x].father != undefined) {
                if (this.boardDiv.childNodes[x].father.id == id) {
                    return this.boardDiv.childNodes[x].father;
                }
            }
        }
        return null;
    },

    appList: {},
    boardDiv: null,
    gridSize: 10,
    ra2: 0,
    rb2: 0,
    rc2: 0,

    onClientMouseUp: function (e) {
        blockBeingRotated = null;
        blockBeingTranslated = null;
        //		toolBeingSized = null;
        e.preventDefault();
    },
    onClientMouseMove: function (e) {
        if (blockBeingTranslated != null) {
            e.preventDefault();
            return blockBeingTranslated.onClientMouseMove(e);
        } else if (blockBeingRotated != null) {
            e.preventDefault();
            return blockBeingRotated.onClientMouseMove(e);
            //			}else if(toolBeingSized != null){
            //				return toolBeingSized.onClientMouseMove(e);
        } else {
            document.body.style.cursor = 'default';
            return true;
        }
    }
};

function Board(flag) {
    this.flag = flag;
}
Board.prototype.__proto__ = protoBoard;


var protoBlock = {
    init: function (touchable) {
        this.div = new CreateComponentDIV(this.type);

        if (this.board.flag == "movable") {
            this.div.addEventListener("touchstart", this.div.onMyMouseDown, false);
            this.div.addEventListener("touchend", this.div.onMyMouseUp, false);
            this.div.addEventListener("mousedown", this.div.onMyMouseDown, false);
            //		z.addEventListener("mousemove", z.onMyMouseMove, false);
            this.div.addEventListener("mouseup", this.div.onMyMouseUp, false);
        }

        this.div.father = this;

        var w = this.width * this.board.gridSize;
        var h = this.height * this.board.gridSize;
        var xc = w / 2;
        var yc = h / 2;

        this.div.style.transformOrigin = xc + "px " + yc + "px";
        this.div.style.msTransformOrigin = xc + "px " + yc + "px";
        this.div.style.MozTransformOrigin = xc + "px " + yc + "px";
        this.div.style.webkitTransformOrigin = xc + "px " + yc + "px";
        this.div.style.OTransformOrigin = xc + "px " + yc + "px";

        /*		if(touchable){
                    this.div.innerHTML = '<img id="pic" style="position:absolute;" src="' + this.picture + '" width="' + w +'px" height="' + h +'px"/><img id="handle" style="position:absolute; visibility:hidden; opacity:0.1; left:' + (xc-0.3*screenWidth) + 'px; top:' + (yc-0.3*screenWidth) + 'px;" src="handle.png" width="' + 0.6*screenWidth + '"/>';
                } else {
                    this.div.innerHTML = '<img id="pic" style="position:absolute;" src="' + this.picture + '" width="' + w +'px" height="' + h +'px"/>';	
                }
        */

        this.div.innerHTML = '<img id="pic" style="position:absolute;" src="' + this.picture + '" width="' + w + 'px" height="' + h + 'px"/>';

        if (touchable) {
            this.divHTop = document.createElement('div');
            this.divHTop.innerHTML = '<img id="handle" style="position:absolute; opacity:0.1; left:' + (xc - 0.2 * screenWidth) + 'px; top:' + (yc - 0.2 * screenWidth) + 'px;" src="rotate_handle.png" width="' + 0.4 * screenWidth + '"/>';
//            this.divHTop.innerHTML = '<img id="handle" style="position:absolute; opacity:0.1; left:' + (xc - 0.2 * screenWidth) + 'px; top:' + (yc - 0.2 * screenWidth) + 'px;" src="rotate_handle.png" width="' + 0.4 * screenWidth + '"/><img id="handleT" style="position:absolute; opacity:0.1; left:' + (xc - 0.05 * screenWidth) + 'px; top:' + (yc - 0.3 * screenWidth) + 'px;" src="move_handle.png" width="' + 0.1 * screenWidth + '"/><img id="handleB" style="position:absolute; opacity:0.1; left:' + (xc - 0.05 * screenWidth) + 'px; top:' + (yc + 0.2 * screenWidth) + 'px;" src="move_handle.png" width="' + 0.1 * screenWidth + '"/><img id="handleL" style="position:absolute; opacity:0.1; left:' + (xc - 0.3 * screenWidth) + 'px; top:' + (yc - 0.05 * screenWidth) + 'px;" src="move_handle.png" width="' + 0.1 * screenWidth + '"/><img id="handleR" style="position:absolute; opacity:0.1; left:' + (xc + 0.2 * screenWidth) + 'px; top:' + (yc - 0.05 * screenWidth) + 'px;" src="move_handle.png" width="' + 0.1 * screenWidth + '"/>';
            this.divHTop.style.visibility = "hidden";
            this.div.appendChild(this.divHTop);
        }

        return this;
    },
    display: function () {
        this.div.style.visibility = "visible";
        return this;
    },
    hide: function () {
        this.div.style.visibility = "hidden";
        return this;
    },
    setLocation: function (x, y) {
        //x, y are in scale of the screen width
        //		var area = this.board.getBounds();
        //		if(x < 0){x = gridRows + x;}
        //		if(y < 0){y = gridRows + y;}
        x = parseFloat(x.toFixed(2));
        y = parseFloat(y.toFixed(2));
        lastX = x;
        lastY = y;
        this.translateX = x * this.board.gridSize;
        this.translateY = y * this.board.gridSize;
        transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);
        return this;
    },
    getLocation: function () {
        //		return {x: this.translateX, y: this.translateY}
        var x = this.translateX / this.board.gridSize;
        var y = this.translateY / this.board.gridSize;
        x = parseFloat(x.toFixed(2));
        y = parseFloat(y.toFixed(2));
        return { x: x, y: y };
    },
    setAngle: function (ang) {
        //		var area = this.board.getBounds();
        ang = parseFloat(ang.toFixed(2));
        lastAngle = ang;
        this.rotateAngle = Math.PI * ang / 180;
        transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);
        return this;
    },
    getAngle: function () {
        //		return this.rotateAngle;
        var ang = this.rotateAngle * 180 / Math.PI;
        ang = parseFloat(ang.toFixed(2));
        return ang;
    },
    //	reSize: function(scale){
    //		this.width = this.width*scale;
    //		this.height = this.height*scale;
    //		this.translateX = this.translateX*scale;
    //		this.translateY = this.translateY*scale;
    //		transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);
    //		return this;
    //	},

    moveToTop: function () {
        this.div.style.zIndex = maxzindex++;
        return this;
    },
    setFilter: function (filter) {
        this.div.style.filter = filter;
        return this;
    },

    width: 0,
    height: 0,
    id: 0,

    //		setScale: function(scale){
    //			if(scale > 2.0){
    //				scale = 2.0;
    //			}else if(scale < 0.5){
    //				scale = 0.5
    //			}

    //			this.div.width = this.base_width*scale;			//reset the canvas with new width and height
    //			this.div.height = this.base_height*scale;

    //			this.scale = scale;
    //			this.relative_scale = 1;

    //			transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);

    //			var area = root.getBounds();
    //		},
    //		getScale: function(scale){
    //			return this.scale;
    //		},
};

function Block(type, width, height) {
    this.width = width;
    this.height = height;
    this.translateX = 0;
    this.translateY = 0;
    this.rotateAngle = 0;
    //		this.scale = 1;
    //		this.relative_scale = 1;
    this.type = 'block';
    this.picture = type;

    this.atRotateHandle = function (x, y, cx, cy) {
        var d2 = (x - cx) * (x - cx) + (y - cy) * (y - cy);
		//var margin = screenWidth*0.1;
		//var t = document.getElementById("titlebar").offsetHeight;
		//if(cx<margin || cx>(workBoard.boardDiv.offsetWidth-margin) || cy<(t+workBoard.boardDiv.offsetTop+margin) || cy>(t+workBoard.boardDiv.offsetTop+workBoard.boardDiv.offsetHeight-margin) ){
		//	if(d2 < this.board.rb2){
		//		return 1;
		//	} else {
		//		return 0;
		//	}
		//}			
        if (d2 < this.board.ra2) {
            return 1;
        } else if (d2 < this.board.rb2) {
            return 2;
//        } else if (d2 < this.board.rc2) {
//            return 1;
        } else {
            return 0;
        }
    }

    //		this.setScale(1);	//initial scale
}
Block.prototype.__proto__ = protoBlock;

function CreateComponentDIV(type) {
    //	var opacity = 0.8;

    var z = document.createElement('div');
    //	z.width = width;
    //	z.height = height;
    z.tabIndex = maxzindex;
    z.visibility = 'inherit';
    z.style.cssText = 'position:absolute; outline:none;';
    //	z.style.opacity = 1.0;
    z.style.zIndex = maxzindex++;

    z.onMyMouseDown = function (e) {

        document.getElementById("report-menu").style.display = "none";

        if (gameover) {
            return; //game has been over
        }

        if (inaction) {
            return; // 已经有板块处于操作状态
        }
        inaction = true;

        if (!e) {
            e = window.event; //IE
        }
        e.preventDefault();
        e.stopPropagation();

        //check Overlapping
        var onme,
            s = '',
            top,
            zIndexMax = -1,
            zIndex,
            offsetX,
            offsetY;

        if (e.type == "touchstart") {
            e = e.touches[0];
        }

        mouseStartX = e.clientX;	//remember the position
        mouseStartY = e.clientY;
        var pos = this.father.board.boardDiv.getBoundingClientRect();
        var centreX = pos.left + this.father.translateX + this.father.board.gridSize * this.father.width / 2;
        var centreY = pos.top + this.father.translateY + this.father.board.gridSize * this.father.height / 2;
        //		var centreX = pos.left + (this.father.translateX + this.father.board.gridSize*this.father.width/2)*this.father.board.gScale;
        //		var centreY = pos.top + (this.father.translateY + this.father.board.gridSize*this.father.height/2)*this.father.board.gScale;

        focusBlock = this;
        var atHandle = this.father.atRotateHandle(mouseStartX, mouseStartY, centreX, centreY);
        if (atHandle == 1) {
            blockBeingTranslated = this;
            blockBeingRotated = null;
            prevX = this.father.translateX;
            prevY = this.father.translateY;
            currentAction = 1;
        } else if (atHandle == 2) {
            blockBeingRotated = this;
            blockBeingTranslated = null;
            var mouseXFromCentre = e.clientX - centreX;
            var mouseYFromCentre = e.clientY - centreY;
            var mouseAngle = Math.atan2(mouseYFromCentre, mouseXFromCentre);
            mouseStartAngle = mouseAngle;
            currentAction = 2;
        } else {
            focusBlock = null;
            currentAction = 0;
        }

        for (var tool in this.father.board.appList) {
            var currentBlock = this.father.board.appList[tool];
            //hidden target blocks (for animated display to show wrong positions) will not be processed
            if (!currentBlock.isTarget) {
                zIndex = currentBlock.div.style.zIndex;
                if (zIndex > zIndexMax) {
                    top = tool;
                    zIndexMax = zIndex;
                }
                currentBlock.div.lastChild.style.visibility = "hidden";
				
                //			currentBlock.div.firstChild.nextSibling.style.visibility = "hidden";
                currentBlock.div.style.filter = 'brightness(100%)';

                //			currentBlock.div.style.filter = 'grayscale(0%)';
                //			currentBlock.div.style.opacity = 1.0;

                if (currentBlock != this.father) {
                    currentBlock.div.blur();
                }
                //			if(currentBlock.inputarea){
                //				currentBlock.inputarea.blur();
                //			}
            }
        }

		//var margin = screenWidth*0.1;
		//var t = document.getElementById("titlebar").offsetHeight;
		//if(centreX<margin || centreX>(workBoard.boardDiv.offsetWidth-margin) || centreY<(t+workBoard.boardDiv.offsetTop+margin) || centreY>(t+workBoard.boardDiv.offsetTop+workBoard.boardDiv.offsetHeight-margin) ){
		//	this.father.divHTop.lastChild.src = "move_handle.png";
		//} else {
		//	this.father.divHTop.lastChild.src = "rotate_handle.png";
		//}
		
        if (this.father.board.appList[top] != this.father) {
            this.father.div.style.zIndex = maxzindex++;
        }

        //show the rotation handle (it is the second image at top of the block picture.
        this.lastChild.style.visibility = "visible";
        //		this.firstChild.nextSibling.style.visibility = "visible";
        this.father.div.style.filter = 'brightness(110%)';

        var gameDate = new Date();
        var t = gameDate.getTime();
        thinkTime = t - currentTime;
        currentTime = t;

        var gridSize = this.father.board.gridSize;
        lastX = this.father.translateX / gridSize;
        lastY = this.father.translateY / gridSize;
        lastX = parseFloat(lastX.toFixed(2));
        lastY = parseFloat(lastY.toFixed(2));
        if (currentMsg.move2grid == 1) {
            lastX = Math.round(this.father.translateX / gridSize);
            lastY = Math.round(this.father.translateY / gridSize);
        }

        lastAngle = DegPerGrid * this.father.rotateAngle / RadPerGrid;
        if (currentMsg.rotate2grid == 1) {
            lastAngle = DegPerGrid * Math.round(this.father.rotateAngle / RadPerGrid);
        }

        return false;
    };

    z.onMyMouseUp = function (e) {

        if (gameover) {
            return; //game has been over
        }

        if (!inaction) {
            return;
        }
        inaction = false;

        e.preventDefault();
        blockBeingRotated = null;
        blockBeingTranslated = null;
        step++;

        var gameDate = new Date();
        var t = gameDate.getTime();
        moveTime = t - currentTime;
        currentTime = t;
        var gridSize = this.father.board.gridSize;

        var msg = new Object();
        msg.step = step;
        msg.id = this.father.id;

        msg.x = this.father.translateX / gridSize;
        msg.y = this.father.translateY / gridSize;
        msg.x = parseFloat(msg.x.toFixed(2));
        msg.y = parseFloat(msg.y.toFixed(2));
        if (currentMsg.move2grid == 1) {
            msg.x = Math.round(this.father.translateX / gridSize);
            msg.y = Math.round(this.father.translateY / gridSize);
        }

        msg.angle = DegPerGrid * this.father.rotateAngle / RadPerGrid;
        msg.angle = parseFloat(msg.angle.toFixed(2));
        if (currentMsg.rotate2grid == 1) {
            msg.angle = DegPerGrid * Math.round(this.father.rotateAngle / RadPerGrid);
        }

        msg.thinkTime = thinkTime;
        msg.moveTime = moveTime;
//        if ((currentAction == 1 && msg.x == lastX && msg.y == lastY) || (currentAction == 2 && msg.angle == lastAngle)) {
        if ((currentAction == 1 && Math.abs(msg.x-lastX)<0.0001 && Math.abs(msg.y-lastY)<0.0001) || (currentAction == 2 && Math.abs(msg.angle-lastAngle)<0.0001) ) {
            msg.action = 0;
            currentAction = 0;
        } else {
            msg.action = currentAction;
            points = points - currentMsg.stepscore;
            opcount++;
        }

		//compare with the last msg for dupilcated sending. Commented as the cause has been found in "==" above (corrected, to be tested)
//		if(oldMsg == null || msg.id != oldMsg.id || msg.action != oldMsg.action || msg.x != oldMsg.x || msg.y != oldMsg.y || msg.angle != oldMsg.angle){
        if (currentMsg.stepscore > 0 && currentAction != 0) {
            var left = gridSize * (msg.x + this.father.width / 2) - 30;
            if (left < 0) {
                left = 5;
            }
            else if (left > screenWidth - 75) {	//width 60 + padding 2x5 = 70
                left = screenWidth - 75;
            }
            document.getElementById("bubble").style.left = left + 'px';
            document.getElementById("bubble").style.top = workBoard.boardDiv.offsetTop + gridSize * msg.y - 40 + 'px';
            document.getElementById("bubble").innerHTML = '-' + currentMsg.stepscore;
            document.getElementById("bubble").style.visibility = "visible";
            timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);
            //			}
            //bubble: 0 - no bubble, 1 - bubble with object, 2 - bubble at center
            if (blockShowOption < 2) {
                msg.bubble = 1;
                sendPeerMsg('move', msg);
            } else {
                sendPeerMsg('move', { "bubble": 2 });
            }
        }
        else {
            if (blockShowOption < 2 && currentAction != 0) {
                sendPeerMsg('move', msg);
            }
        }
		param = 'obj=' + msg.step + '_' + msg.id + '_' + msg.action + '_' + msg.x + '_' + msg.y + '_' + msg.angle + '_' + msg.thinkTime + '_' + msg.moveTime;
		requestServer(apiCode, "Move", param);
//			oldMsg = msg;
			
//		}
        //var pos = this.father.board.boardDiv.getBoundingClientRect();
        //var centreX = pos.left + this.father.translateX + this.father.board.gridSize * this.father.width / 2;
        //var centreY = pos.top + this.father.translateY + this.father.board.gridSize * this.father.height / 2;
		//var margin = screenWidth*0.1;
		//var t = document.getElementById("titlebar").offsetHeight;
		//if(centreX<margin || centreX>(workBoard.boardDiv.offsetWidth-margin) || centreY<(t+workBoard.boardDiv.offsetTop+margin) || centreY>(t+workBoard.boardDiv.offsetTop+workBoard.boardDiv.offsetHeight-margin) ){
		//	this.father.divHTop.lastChild.src = "move_handle.png";
		//} else {
		//	this.father.divHTop.lastChild.src = "rotate_handle.png";
		//}

        //forced to align blcoks to grid so as to eliminate accumulated errors (previously x/y/a are not aligned)
        this.father.translateX = gridSize * msg.x;
        this.father.translateY = gridSize * msg.y;
        this.father.rotateAngle = RadPerGrid * msg.angle / DegPerGrid;

        if (currentAction != 0 && actionFile != '') {
            AE_onMove(msg);
        }

        return false;
    };

    z.onClientMouseMove = function (e) {

        if (gameover) {
            return; //game has been over
        }

        if (!e) {
            e = window.event; //IE
        }
        e.preventDefault();

        if (e.type == "touchmove") {
            e = e.touches[0];
        }

        var clientX = (e.clientX),
            clientY = (e.clientY);

        var pos = this.father.board.boardDiv.getBoundingClientRect();
        var gridSize = this.father.board.gridSize;

        if (blockBeingTranslated != null) {
            me = blockBeingTranslated;
            var newX = prevX + clientX - mouseStartX;
            var newY = prevY + clientY - mouseStartY;

            var xx = newX / gridSize;
            var yy = newY / gridSize;
            if (currentMsg.move2grid == 1) {
                xx = Math.round(newX / gridSize);
                yy = Math.round(newY / gridSize);
            }

            if (xx + this.father.width / 2 < 0 || xx + this.father.width / 2 > currentMsg.gridsize ||
                yy + this.father.height / 2 < 0 || yy + this.father.height / 2 > currentMsg.gridsize) {
                return false;
            }

            me.father.translateX = newX;
            me.father.translateY = newY;
        } else if (blockBeingRotated != null) {												//rotate action
            me = blockBeingRotated;
            var mouseXFromCentre = e.clientX - pos.left - me.father.translateX - gridSize * this.father.width / 2;
            var mouseYFromCentre = e.clientY - pos.top - me.father.translateY - gridSize * this.father.height / 2;
            //			var mouseXFromCentre = e.clientX - pos.left - (me.father.translateX - gridSize*this.father.width/2)*this.father.board.gScale;
            //			var mouseYFromCentre = e.clientY - pos.top - (me.father.translateY - gridSize*this.father.height/2)*this.father.board.gScale;
            var mouseAngle = Math.atan2(mouseYFromCentre, mouseXFromCentre);
            me.father.rotateAngle += mouseAngle - mouseStartAngle;
            mouseStartAngle = mouseAngle;
        } else {
            me = this;
            return false;
        }

        transformBlock(me.father.div, me.father.translateX, me.father.translateY, me.father.rotateAngle);

        return false;
    };

    z.getAng = function (a, b) {
        if (Math.abs(a) > Math.abs(b)) {
            var ang = Math.atan(b / a);
            if (a < 0) ang += Math.PI;
        } else {
            var ang = Math.PI / 2 - Math.atan(a / b);
            if (b < 0) ang += Math.PI;
        }
        return ang;
    }

    return z;
}

/*function fixTo(a, b){
	var f = Math.round;
	if(b===0)     return f(a);
	else if(b==1) return f(a*10)/10;
	else if(b==3) return f(a*1000)/1000;
	else		  return f(a*100)/100
}
*/
function transformBlock(ele, x, y, a) {
    //align displayed blocks to grid. Please note x/y/a of the block object itself are not aligned
    var gridSize = ele.father.board.gridSize;
    var s = ele.father.board.gScale;

    var xx = x;
    var yy = y;
    if (currentMsg.move2grid == 1) {
        xx = gridSize * Math.round(x / gridSize);
        yy = gridSize * Math.round(y / gridSize);
    }

    var str = ele.style.transformOrigin.split("px");
    xx = xx * s + parseInt(str[0]) * (s - 1);
    yy = yy * s + parseInt(str[1]) * (s - 1);

    var alpha = DegPerGrid * a / RadPerGrid;
    if (currentMsg.rotate2grid == 1) {
        alpha = DegPerGrid * Math.round(a / RadPerGrid);
    }

    ele.style.webkitTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
    ele.style.MozTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
    ele.style.msTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
    ele.style.OTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
    ele.style.transform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
}

function onCountdown(msg) {
    if (actionFile == '') {
        //		document.getElementById("snd_ready").loop = false;
        document.getElementById("snd_ready").play();
    }
    initMsg = msg;

    //	JavaScriptInterface.nativeCommand('setTitle', '{"title":"沟通成本（' + msg.levelname + '）"}');
    if (msg.targetshapes != undefined) {
        role = 'teller';
    } else {
        role = 'listener';
    }

    if (startMode != 1) {
        onInit();
        return;
    }
    //	document.getElementById("countdownprompt").innerHTML = '比赛即将开始...';

    if (msg.countdown > 0) {
        countdown = Math.floor(msg.countdown / 1000);
    } else {
        countdown = 0;
    }

    //start voice at end of countdown time, or start immediately if it is zero or negative
    if (role == 'teller') {
        if (countdown > 0) {
            timer4 = setTimeout(startVoice, countdown * 1000);
        } else {
            startVoice();
        }
    } else if (role == 'listener') {
        timer4 = setTimeout(onInit, (countdown + 2) * 1000);
    }

    //display countdown with additional 2 seconds (2 seconds after starting voice)
    countdown = countdown + 2;
    document.getElementById("countdown").innerHTML = countdown;
    document.getElementById("countdown").style.visibility = 'visible';
    timer1 = setInterval('countdown--;document.getElementById("countdown").innerHTML = countdown;', 1000);

    requestServer("GameLog", "Add", "logtype=Init&details=countdown_start");
}

function startVoice() {
    if (actionFile == '') {
        JavaScriptInterface.nativeCommand('startVoice', '');
    }
    //init page 2 seconds after starting voice 
    timer4 = setTimeout(onInit, 2000);
    //	requestServer("GameLog", "Add", "logtype=Init&details=startvoice");
}

function onInit() {

    var myL, myT, myW, myH;
    var msg = initMsg;
    //	var targetbackground_i;
    var targetviewport;

    var gameDate = new Date();
    startTime = gameDate.getTime();

    if (msg.level != undefined) {
        switch (msg.level) {
            case 0: backgroundOption = 1;	//1 - fixed
                blockShowOption = 0;	//0 - display all time
                blockMoveOption = 0;	//0 - forced in place
                break;
            case 1: backgroundOption = 2;	//2 - selectable
                blockShowOption = 1;	//1 - display after background is set
                blockMoveOption = 0;	//0 - forced in place
                break;
            case 2: backgroundOption = 2;	//2 - selectable
                blockShowOption = 2;	//2 - display only when block is in place
                blockMoveOption = 0;	//0 - forced in place
                break;
            case 3: backgroundOption = 2;	//2 - selectable
                blockShowOption = 3;	//3 - display only when all blocks are in place
                blockMoveOption = 1;	//1 - no forced in place
                break;
            case 4: backgroundOption = 3;	//3 - selectable and hidden at the teller side
                blockShowOption = 3;	//2 - display only when all blocks are in place
                blockMoveOption = 1;	//1 - no forced in place
        }
    }

    if (msg.backgroundoption != undefined) {
        backgroundOption = msg.backgroundoption;
    }
    if (msg.blockshowoption != undefined) {
        blockShowOption = msg.blockshowoption;
    }
    if (msg.blockmoveoption != undefined) {
        blockMoveOption = msg.blockmoveoption;
    }

    //	requestServer("GameLog", "Add", "logtype=Init&details=init_start");

    document.getElementById('titlebar').style.visibility = "visible";
    document.getElementById('titlebar').style.width = "100%";
    //	document.getElementById('board-page').style.visibility = "visible";
    document.getElementById('board-page').style.display = "block";
    document.getElementById('countdown-page').style.visibility = "hidden";
    clearInterval(timer1);

    switch (msg.levelname) {
        case '普通':
            document.getElementById('board-page').style.backgroundColor = "rgb(219,249,239)";
            break;
        case '困难':
            document.getElementById('board-page').style.backgroundColor = "rgb(249,236,219)";
            break;
        case '地狱':
            document.getElementById('board-page').style.backgroundColor = "rgb(223,203,253)";
            break;
    }


    document.getElementById("board-page").style.display = "block";
    document.getElementById("board-page").addEventListener("mousedown", onClearFocus, false);
    document.getElementById("board-page").addEventListener("touchstart", onClearFocus, false);
    document.getElementById("background-page").addEventListener("mousedown", onClearFocus, false);
    document.getElementById("background-page").addEventListener("touchstart", onClearFocus, false);

    if (msg.partner != undefined) {
        document.getElementById("partner").innerHTML = msg.partner;
    }

    startCountdownClock(msg.timelimit);

    //	titleHeight =  document.getElementById("points").scrollHeight;
    titleHeight = 0;
    starHeight = 30;

    currentMsg = msg;
    points = msg.maxscore;

    if (msg.pair != undefined) {
        pair = msg.pair;
    }

    DegPerGrid = 360 / currentMsg.anglesize;
    RadPerGrid = 2 * Math.PI / currentMsg.anglesize;

    myL = 0;
    myW = screenWidth;
    myH = screenWidth;
    myT = screenHeight - titleHeight - screenWidth;
    if (myT < screenWidth / 4) {
        myT = screenWidth / 4;
        myW = screenHeight - titleHeight - myT;
        myH = myW;
    } else if (myT > screenWidth / 2) {
        myT = screenWidth / 2;
    }

    if (role == 'teller') {
        document.getElementById("hints").style.top = titleHeight + starHeight + 'px';
    } else {
        document.getElementById("hints").style.top = titleHeight + 'px';
    }

    if (backgroundOption < 2) {
        //use first background in the array for "fixed background" and no use for "no background"
        targetbackground_i = 0;
    } else {
        //find target background index in the array, if background is selectable
        for (var i = 0; i < msg.backgrounds.length; i++) {
            if (msg.backgrounds[i].bgidx == msg.targetbackgroundidx) {
                targetbackground_i = i;
                break;
            }
        }
    }

    var gameDate = new Date();
    currentTime = gameDate.getTime();

    //	timer4 = setTimeout("JavaScriptInterface.nativeCommand('micOn', '')", 1000);
    initButton('reportButton', 'rgb(25,189,190)', '#F0F0F0');

    if (role == 'teller') {
        //		JavaScriptInterface.nativeCommand('startVoice', '');

        workBoard = new Board('viewOnly');
        workBoard.setBounds('workArea', myL, myT + titleHeight, myW, myH, currentMsg.gridsize);

        //target viewport is reserved for future use. The background currently does not support target viewport
        targetviewport = msg.targetviewport;
        if (targetviewport == undefined) {
            targetviewport = new Object();
            targetviewport.posx = 0;
            targetviewport.posy = 0;
            targetviewport.size = currentMsg.gridsize;
        }

        document.getElementById("lookButton").style.top = myT + titleHeight - 2*document.getElementById("lookButton").clientHeight - 10 + 'px';
        document.getElementById("reportButton").style.top = myT + titleHeight - document.getElementById("reportButton").clientHeight - 5 + 'px';
		
		if(blockShowOption == 3 && msg.looktime != undefined && msg.looktime >= 0) {
			document.getElementById('lookButton').style.visibility = "visible";
			disableButton(document.getElementById('lookButton'));

			if(backgroundOption < 2) {
				if(currentMsg.looktime == 0) {
					initButton('lookButton', 'rgb(25,189,190)', '#F0F0F0');
				} else {
					setTimeout("initButton('lookButton', 'rgb(25,189,190)', '#F0F0F0');", currentMsg.looktime*1000);
				}
			}
		}

        myL = 5;
        myW = myT - 10;
        myH = myT - 10;
        myT = 5;
        targetBoard = new Board('viewOnly');
        targetBoard.setBounds('targetArea', myL, myT + titleHeight, myW, myH, targetviewport.size);
        correctBackgroundFile = msg.backgrounds[targetbackground_i].shapename;
        //		currentBackgroundFile = correctBackgroundFile;
        if (backgroundOption > 0) {
            targetBoard.setBackground(correctBackgroundFile);
        }

        if (backgroundOption > 1) {
            document.getElementById("hints").innerHTML = "向对方描述屏幕上方图样";
            document.getElementById("prompt").innerHTML = "TA选择后才能看到图形";
        }

        //		if(blockShowOption == 3){
        //			document.getElementById("prompt").innerHTML = "此难度看不到TA的操作";
        //		}

        document.getElementById("hints").style.left = myW + 10 + 'px';
        document.getElementById("hints").style.width = screenWidth - myW - 10 + 'px';

        // to be changed for Tutorial		
        /*		if(isOffline){
                    //simulate movement from another player
                    if(backgroundOption == 2){
                        timer2 = setTimeout("onChgBkg({'type': 'chgBkg', 'id':5, 'picname':'sample5.jpg'});timer2 = setInterval(simulateMoves,2000);", 3000);
                    } else {
                        timer2 = setInterval(simulateMoves,2000);
                    }
                }
        */
    }
    else if (role == 'listener') {
        //		timer4 = setTimeout("JavaScriptInterface.nativeCommand('micOn', '')", 2500);
        JavaScriptInterface.nativeCommand('micOn', '');

        document.getElementById("targetArea").style.visibility = "hidden";
        document.getElementById("prompt").style.visibility = "hidden";
        if (backgroundOption > 1) {
            document.getElementById('bkgButton').style.visibility = "visible";
            //			initButton('bkgButton', 'white');
            initButton('bkgButton', 'rgb(25,189,190)', '#F0F0F0');

            initButton('reportButton2', 'rgb(25,189,190)', '#F0F0F0');
            //			document.getElementById("reportButton2").style.top = document.getElementById("reportButton").style.top;

            for (var i = 0; i < msg.backgrounds.length; i++) {

                var imgNode = document.createElement("img");
                imgNode.id = msg.backgrounds[i].bgidx;
                imgNode.src = msg.backgrounds[i].shapename;
                imgNode.shapepath = msg.backgrounds[i].shapename;
                imgNode.className = 'imageItem';
                imgNode.onclick = onSelectPic;

                document.getElementById("image-list").appendChild(imgNode);
                imgNode.addEventListener("touchstart", onTouchPic, true);
                imgNode.addEventListener("touchmove", onTouchMove, true);
            }
        }

        workBoard = new Board('movable');
        workBoard.setBounds('workArea', myL, myT + titleHeight, myW, myH, currentMsg.gridsize);
        document.getElementById("image-panel").style.top = myT + titleHeight + 'px';

        if (backgroundOption > 1) {
            //			document.getElementById("bkgButton").style.top = myT + titleHeight - document.getElementById("bkgButton").clientHeight*2 - 30 + 'px';
            onChangeBackground(true);
            document.getElementById("hints").innerHTML = '没选对背景。请点击"改变背景"重新选择背景';
        } else {
            if (typeof (mainHint) != "undefined") {
                document.getElementById("hints").innerHTML = mainHint;
            } else if (blockShowOption == 2) {
                document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品。移对了对方才能看到该物品";
            } else if (blockShowOption == 3) {
                document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品。所有物品移对了对方才能看到";
            } else {
                document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品";
            }
        }
    }

    //create blocks and set block position and visibility
    for (x in msg.shapes) {
        var s = msg.shapes[x];
        var b1 = workBoard.createBlock(s.shapename, s.shapeid, s.width, s.length, true);
        var b2 = workBoard.createBlock(s.shapename, s.shapeid + 100, s.width, s.length, false);
        b2.isTarget = true;

        //setup init blocks
        if (msg.initshapes == undefined) {
            //happens when blockShowOption is 2 and 3
            var sp = msg.targetshapes[x];
        } else {
            var sp = msg.initshapes[x];
        }
        b1.setLocation(sp.posx, sp.posy);
        b1.setAngle(sp.angle);
        b1.display();
        //		if(role == 'listener' || blockShowOption == 0){
        //		if(blockShowOption == 0 || backgroundOption < 2){
        if ((role == 'listener' && backgroundOption < 2) || blockShowOption == 0) {
            b1.display();
        } else {
            b1.hide();
        }

        //setup blocks in final position for comparison when ended with "zero" 
        b2.setLocation(sp.posx, sp.posy);
        b2.setAngle(sp.angle);
        b2.hide();

        //create and setup target blocks
        if (role == 'teller') {
            var b = targetBoard.createBlock(s.shapename, s.shapeid, s.width, s.length, false);
            var sp = msg.targetshapes[x];
            b.setLocation(sp.posx, sp.posy);
            b.setAngle(sp.angle);
            if (backgroundOption < 2) {
                b.display();
            } else {
                b.hide();
            }
        }
    }

    //backgroundOption 0 has no background, 2 and 3 are selected by the listener
    if (backgroundOption == 1) {
        workBoard.setBackground(msg.backgrounds[targetbackground_i].shapename);
    }

    //	textPoints = document.getElementById('points');
    //	textPoints.innerHTML = '得分 ' + points;
    //	document.getElementById("timepoints").innerHTML = countdownClock + " / " + points;
    //	document.getElementById("timepoints").innerHTML = "\u{1F552} " + countdownClock + " / \u{1F3F3} " + points;
    //	document.getElementById("timepoints").innerHTML = "\uD83D\uDD52 " + countdownClock + " / \uD83C\uDFF3 " + points;
    document.getElementById("timepoints").innerHTML = "\u23F1 " + countdownClock + " / \u2690 " + points;
    timer1 = setInterval(displayPoints, 100);

    if (msg.examinfo != undefined && msg.examinfo.show != false) {
        updateStar(msg.examinfo.star, msg.examinfo.point, msg.examinfo.total);
        pointToNextStar = msg.examinfo.total - msg.examinfo.point;
        currentStar = msg.examinfo.star;
    }

    if (actionFile == '') {
        startHeartbeat();
    } else {
        doNextAction();
    }

    requestServer("GameLog", "Add", "logtype=Init&details=init_complete");
    //requestServer("GameLog", "Add", "logtype=Init&details=blockShowOption：" + blockShowOption);

}

function onClearFocus() {
    document.getElementById("report-menu").style.display = "none";

    if (role != 'listener') {
        return;
    }

    if (focusBlock != null) {
        focusBlock.lastChild.style.visibility = "hidden";
        //		focusBlock.firstChild.nextSibling.style.visibility = "hidden";
        focusBlock.style.filter = 'brightness(100%)';
        focusBlock = null;
    }
}

function onSwitchSize(tappedBoard) {

    if (gameover) {
        return;
    }

    if ((tappedBoard == targetBoard.boardDiv && isLargeTargetBoard) || (tappedBoard == workBoard.boardDiv && !isLargeTargetBoard)) {
        return;
    }

    var rectWork = targetBoard.getBounds();
    var rectTarget = workBoard.getBounds();

    isLargeTargetBoard = !isLargeTargetBoard;

    if (isLargeTargetBoard) {
        rectTarget.top = 0;
        rectWork.top = rectTarget.height + 5;
        document.getElementById("starprogress").style.top = rectTarget.height + "px";
        document.getElementById("hints").style.top = rectTarget.height + starHeight + "px";
        document.getElementById("lookButton").style.top = rectTarget.height + rectWork.height - 2*document.getElementById("lookButton").clientHeight - 10 + 'px';
        document.getElementById("reportButton").style.top = rectTarget.height + rectWork.height - document.getElementById("reportButton").clientHeight - 5 + 'px';
        document.getElementById("report-menu").style.top = rectWork.top + 50 + 'px';
    } else {
        rectTarget.top = 5;
        rectWork.top = rectTarget.height + 10;
        document.getElementById("starprogress").style.top = "0px";
        document.getElementById("hints").style.top = starHeight + "px";
        document.getElementById("lookButton").style.top = rectTarget.height - 2*document.getElementById("lookButton").clientHeight - 10 + 'px';
        document.getElementById("reportButton").style.top = rectTarget.height - document.getElementById("reportButton").clientHeight - 5 + 'px';
        document.getElementById("report-menu").style.top = rectTarget.top + 50 + 'px';
    }
    targetBoard.resizeBounds(rectTarget);
    workBoard.resizeBounds(rectWork);
}

function onMove(movemsg) {
    //Note: this function is to process messages from the peer, not from the server

    if (movemsg.isright) {
        sendPeerMsg('inplaceAck');
    }

    var a = workBoard.findBlock(movemsg.id);
    if (a != null) {
        if (blockShowOption == 2) {
            if (movemsg.isright) {
                a.display();
            }
        }

        a.setLocation(movemsg.x, movemsg.y);
        a.setAngle(movemsg.angle);
        a.div.style.zIndex = maxzindex++;

        if (!movemsg.isright) {
            //do it only for normal moves, instead of the finish message (forced in-place)
            if (movemsg.action != 0) {
                points = points - currentMsg.stepscore;
            }
        }
    }
	
	if(movemsg.bubble != undefined){
		if(a != null && movemsg.bubble == 1){
			var left = workBoard.gridSize*(movemsg.x + a.width/2) - 30;
			if(left<5){
				left = 5;
			} else if(left> screenWidth-75){	//width 60 + padding 2x5 = 70
				left = screenWidth-75;
			}
			document.getElementById("bubble").style.left = left + 'px';
			document.getElementById("bubble").style.top = workBoard.boardDiv.offsetTop + workBoard.gridSize*movemsg.y + 'px';
		} else if(a == null || movemsg.bubble == 2){
			document.getElementById("bubble").style.left = workBoard.boardDiv.offsetWidth/2 - 30 + 'px';
			document.getElementById("bubble").style.top = workBoard.boardDiv.offsetTop + workBoard.boardDiv.offsetHeight/2 + 'px';
		}
		document.getElementById("bubble").innerHTML = '-' + currentMsg.stepscore;
		document.getElementById("bubble").style.visibility = "visible";
		timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);	
	}
}

function onChgBkg(msg) {
    //	document.getElementById("workArea").style.backgroundImage = 'url('+msg.picname+')';

    if (backgroundOption == 2) {
        workBoard.setBackground(msg.picname);
    }
    currentBackgroundFile = msg.picname;
    currentBG = msg.id;

    //check if this background is the correct one. If yes, show all objects and change the prompt
    if (msg.id == currentMsg.targetbackgroundidx) {
        onCorrectBkg();
    } else {
        document.getElementById("prompt").innerHTML = "TA正在选图形...";
    }
}

function onCorrectBkg() {

    if (backgroundOption > 1) {
        for (x in currentMsg.targetshapes) {
            var a = targetBoard.findBlock(currentMsg.targetshapes[x].shapeid);
            a.display();
        }
    }

    if (blockShowOption == 1) {
        for (x in currentMsg.initshapes) {
            var a = workBoard.findBlock(currentMsg.initshapes[x].shapeid);
            a.display();
        }
    }

    if (blockShowOption == 2) {
        document.getElementById("hints").innerHTML = "指挥对方移动物品，对方移对了你就能看到该物品";
        document.getElementById("prompt").innerHTML = "TA在做的";
    } else if (blockShowOption == 3) {
        document.getElementById("hints").innerHTML = "指挥对方移动物品，对方全部物品移对了你才能看到";
        document.getElementById("prompt").innerHTML = "此难度看不到TA的操作";
    } else {
        document.getElementById("hints").innerHTML = "指挥对方移动物品，拼成屏幕上方图样";
        document.getElementById("prompt").innerHTML = "TA在做的";
    }

    if(blockShowOption == 3 && currentMsg.looktime != undefined) {
	    if(currentMsg.looktime == 0) {
			initButton('lookButton', 'rgb(25,189,190)', '#F0F0F0');
		} else {
            setTimeout("initButton('lookButton', 'rgb(25,189,190)', '#F0F0F0');", currentMsg.looktime*1000);
		}
    }
    points -= currentMsg.bgscore;
}

function onLook() {
	//do not popup if there is another dialogbox is displayed
	if (dialogType != null) {
		return;
	}
	
	if(isSimulation)
	{
		//to make it simple, use final position to replace current position
		onLookDone(initMsg.targetshapes);
		return;
	}

	dialogType = DIA_LOOK;
    JavaScriptInterface.nativeCommand('dialogBox', '{\"title\":\"' + gameName + '\",\"msg\":\"使用看一眼功能，可看到操作方各个板块当前的位置，但需要付出2000分的代价。请与操作方协商决定。是否确认使用？\",\"lbtn\":\"取消\",\"rbtn\":\"确定\"}');
}

function onLookDone(shapes) {

    for (x in shapes) {
        var s = shapes[x];
		var a = workBoard.findBlock(s.shapeid);
		if (a != null) {
			if (blockShowOption == 3) {
				a.setLocation(s.posx, s.posy);
				a.setAngle(s.angle);
				a.div.style.zIndex = maxzindex++;
				a.display();
			}
		}
	}
	
	document.getElementById("hints").innerHTML = "当前对象位置是上次看一眼时的状态”"	
	disableButton(document.getElementById('lookButton'));
	setTimeout("initButton('lookButton', 'rgb(25,189,190)', '#F0F0F0');", 10000);
    sendPeerMsg('look');
}

function onPeerLook() {
	document.getElementById("hints").innerHTML = "对方使用了 <span class='redlarge_text'>" + (iLook++) + "</span> 次看一眼功能";
	document.getElementById("snd_ready").play();
	points -= currentMsg.lookscore;
}

function onGameTimeout() {
    if (role == 'listener') {
        requestServer(apiCode, "Zero");
    }
    //	document.getElementById("timepoints").innerHTML = countdownClock + " / " + points;
    //	document.getElementById("timepoints").innerHTML = "\u{1F552} " + 0 + " / \u{1F3F3} " + points;
    //	document.getElementById("timepoints").innerHTML = "\uD83D\uDD52 " + countdownClock + " / \uD83C\uDFF3 " + points;
    document.getElementById("timepoints").innerHTML = "\u23F1 " + countdownClock + " / \u2690 " + points;
    //	document.getElementById("countdownClock").innerHTML = "剩余时间：0 秒";

    clearInterval(timer1);

    if (actionFile != '') {
        AE_timeout();
    }
}

function onTouchPic(e) {
    if (!e.target.selected) {
        a = e.target;
        setTimeout("a=null;", 400);
    }
}

function onTouchMove(e) {
    a = null;
}

function onChangeBackground(isInit) {
    document.getElementById('background-page').style.display = "block";
    document.getElementById('board-page').style.display = "none";
    document.getElementById("report-menu").style.display = "none";

    var gameDate = new Date();
    var t = gameDate.getTime();
    thinkTime = t - currentTime;
    currentTime = t;

    if (actionFile != '' && !isInit) {
        AE_onChangeBackgroundButton();
    }
}

function onSelectPic(image) {
    //	if(a!=null){
    document.getElementById('board-page').style.display = "block";
    document.getElementById('background-page').style.display = "none";
    document.getElementById("report-menu").style.display = "none";

    if (image != null) {
        //			document.getElementById("workArea").style.backgroundImage = 'url('+image.target.src+')';
        workBoard.setBackground(image.target.src);

        step++;
        var gameDate = new Date();
        var t = gameDate.getTime();
        var operateTime = t - currentTime;
        currentTime = t;
        param = 'obj=' + step + '_' + image.target.id + '_' + thinkTime + '_' + operateTime;
        requestServer(apiCode, "ChgBG", param);

        currentBG = image.target.id;
        currentBackgroundFile = image.target.src;
        currentAction = 0;

        sendPeerMsg('chgBG', { "id": image.target.id, "picname": image.target.shapepath });

        points -= currentMsg.bgscore;
		document.getElementById("bubble").style.left = '';
		document.getElementById("bubble").style.top ='-5px';
		document.getElementById("bubble").style.right ='10px';
        document.getElementById("bubble").innerHTML = '-' + currentMsg.bgscore;
        document.getElementById("bubble").style.visibility = "visible";
        timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);

        if (actionFile != '') {
            for (var t = Date.now(); Date.now() - t <= 100;);
            AE_onChangebackground(image.target.id == currentMsg.targetbackgroundidx);
        }
    }
    //	}
}

function resendInplaceMove() {
    sendPeerMsg('move', lastMoveMsg);
    if (resendCount < 2) {
        timer2 = setTimeout(resendInplaceMove, 2500);
        resendCount++;
    }
}

function onFinish(request, msg) {
    //on response from the server for Move, Zero and ChgBg request, only use to check finishing of the game
    var duration = 1500;

    if (gameover) {
        return; //game has been over
    }

    if (msg.score != undefined) {
        //this should be the score returned from server
        points = msg.score;
    }
    /*	} else {
            //when server does not return scores, do it locally
            points -= currentMsg.stepscore;
            points = (points<0) ? 0 : points;
        }*/
    //	textPoints.innerHTML = '得分 ' + points;
    //	document.getElementById("timepoints").innerHTML = countdownClock + " / " + points;
    //	document.getElementById("timepoints").innerHTML = "\u{1F552} " + countdownClock + " / \u{1F3F3} " + points;
    //	document.getElementById("timepoints").innerHTML = "\uD83D\uDD52 " + countdownClock + " / \uD83C\uDFF3 " + points;
    document.getElementById("timepoints").innerHTML = "\u23F1 " + countdownClock + " / \u2690 " + points;

    if (request == 'Move') {
//        if (currentMsg.stepscore > 0 && currentAction != 0) {
//            document.getElementById("bubble").innerHTML = '-' + currentMsg.stepscore;
//            document.getElementById("bubble").style.visibility = "visible";
//            timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);
//        }

        if (msg.isright == true && blockMoveOption == 0) {
            var a = workBoard.findBlock(msg.shapeIdx);
            if (a != null) {
                //				requestServer("GameLog", "Add", "logtype=in-place&details=x:"+msg.posx+"y:"+msg.posy);
                a.div.removeEventListener("touchstart", a.div.onMyMouseDown, false);
                a.div.removeEventListener("touchend", a.div.onMyMouseUp, false);
                a.div.removeEventListener("mousedown", a.div.onMyMouseDown, false);
                a.div.removeEventListener("mouseup", a.div.onMyMouseUp, false);
                a.setLocation(msg.posx, msg.posy);
                a.setAngle(msg.angle);
                a.div.style.zIndex = deadzindex;
                document.getElementById("snd_inplace").play();
            }

            if (blockShowOption < 3) {
                msg.x = msg.posx;
                msg.y = msg.posy;
                msg.id = msg.shapeIdx;
                sendPeerMsg('move', msg);

                lastMoveMsg = msg;
                timer2 = setTimeout(resendInplaceMove, 2500);
                resendCount = 0;
            }

            requestServer("GameLog", "Add", "logtype=Move&details=move in place:" + msg.id);
        }
    } else if (request == 'ChgBG' && msg.isright == true) {
        if (blockShowOption == 2) {
            document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品。移对了对方才能看到该物品";
        } else if (blockShowOption == 3) {
            document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品。所有物品移对了对方才能看到";
        } else {
            document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品";
        }
        disableButton(document.getElementById("bkgButton"));
        if (blockShowOption > 0) {
            for (x in currentMsg.initshapes) {
                var a = workBoard.findBlock(currentMsg.initshapes[x].shapeid);
                a.display();
            }
        }

        //		sendPeerMsg('correctBkg');
        //		correctBackgroundFile = currentBackgroundFile;
    }

    if (msg.next == 0) {
        if (role == 'listener') {
            sendPeerMsg('syncpoint', { "points": points });
        }
        return;
    }

    // following code is executed only once when game is over

    //	if(role == 'listener'){
    //		requestServer("GameLog", "Add", "logtype=Debug&details=finish_1" + msg.id);
    //	}

    if (role == 'teller') {
        if (isLargeTargetBoard) {
            onSwitchSize();
        }
    }

    gameover = true;
    clearInterval(timer1);
    clearInterval(timer5);		//end heartbeat
    clearInterval(timerCountdownClock);
    document.getElementById("report-menu").style.display = "none";
    disableButton(document.getElementById("reportButton"));
    disableButton(document.getElementById("reportButton2"));

    var gameDate = new Date();
    totalTime = gameDate.getTime() - startTime;

    if (points > 0) {
        //	if(msg.score > 0){
        document.getElementById("snd_success").play();
    }
    //	JavaScriptInterface.nativeCommand('micOff', '');
    JavaScriptInterface.nativeCommand('endVoice', '');
    nextGame = msg.next;

    if (actionFile == '') {
        if (role == 'listener') {
            //notify the teller to display all blocks at final position at the teller side when finished (for level 3,4,5)
            msg.finalpos = new Array();
            for (x in currentMsg.shapes) {
                var b = currentMsg.shapes[x];
                var a = workBoard.findBlock(b.shapeid);
                var p = a.getLocation();
                p.angle = a.getAngle();
                p.id = b.shapeid;
                msg.finalpos.push(p);
            }
            //		requestServer("GameLog", "Add", "logtype=Debug&details=finish_2" + msg.id);
            sendPeerMsg('finish', msg);
        } else if (msg.finalpos != undefined) {
            //told by the listener to display all blocks at the final position
            var pos = msg.finalpos;
            for (var i = 0; i < pos.length; i++) {
                var a = workBoard.findBlock(pos[i].id);
                if (a != null) {
                    a.setLocation(pos[i].x, pos[i].y);
                    a.setAngle(pos[i].angle);
                    a.display();
                }
            }

            if (backgroundOption > 1) {
                workBoard.setBackground(currentBackgroundFile);
            }
        }
    }
    /*	else {
            for(var i=0; i<initMsg.initshapes.length; i++){
                var a = workBoard.findBlock(initMsg.initshapes[i].shapeid);
                if(a != null){
                    a.display();
                }
            }
            workBoard.setBackground(currentBackgroundFile);
        }
    */
    document.getElementById("score").innerHTML = msg.score;

    finishMsg = msg;

    //only does it when returns from "zero" (both teller and listener)
    if (backgroundOption > 1 && msg.targetbackgroundidx != undefined && msg.targetbackgroundidx != currentBG) {
        document.getElementById("prompt").innerHTML = "背景选错了！";
        document.getElementById('prompt').style.visibility = "visible";

        for (x in currentMsg.backgrounds) {
            if (currentMsg.backgrounds[x].bgidx == msg.targetbackgroundidx) {
                correctBackgroundFile = currentMsg.backgrounds[x].shapename;
            }
        }

        rightResult = true;
        timerRightPos = setInterval(showRightBackgroud, 1500);

        duration = 10000;
    } else if (msg.targetshapes != undefined) {
        for (x in msg.targetshapes) {
            var s = msg.targetshapes[x];
            var a = workBoard.findBlock(s.shapeid + 100);
            a.setLocation(s.posx, s.posy);
            a.setAngle(s.angle);
            a.moveToTop();
        }
        for (x in currentMsg.shapes) {
            var b = currentMsg.shapes[x];
            var a = workBoard.findBlock(b.shapeid);
            a.setFilter("grayscale(70%) brightness(130%)");
        }

        //		workBoard.setFilter("grayscale(100%) brightness(120%)");
        document.getElementById("mask").style.visibility = "visible";
        document.getElementById("prompt").innerHTML = "没移对！闪烁位置才对！";

        document.getElementById('prompt').style.visibility = "visible";
        rightResult = true;
        timerRightPos = setInterval(showRightPosition, 500);

        duration = 10000;
    }

    if (msg.next > 0 && msg.record != undefined) {
        if (msg.score > msg.record.score && msg.score >= 5000) {
            JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"恭喜，您破本题记录了！\",\"t\":\"3\"}');
            if (isSimulation) {
                alert('您破本题记录了！');
            }
        }
        duration += 3000;
    }

    //	timer3 = setTimeout(showResult, duration);
    timer3 = setTimeout(onNextStep, duration);
}

function showRightBackgroud() {
    if (rightResult) {
        workBoard.setBackground(correctBackgroundFile);
        document.getElementById("prompt").innerHTML = "这才是正确背景";
    } else {
        workBoard.setBackground(currentBackgroundFile);
        document.getElementById("prompt").innerHTML = "背景选错了！";
    }
    rightResult = !rightResult;
}

function showRightPosition() {
    for (x in finishMsg.targetshapes) {
        var b = finishMsg.targetshapes[x];
        var c = workBoard.findBlock(b.shapeid + 100);
        if (rightResult) {
            c.display();
        } else {
            c.hide();
        }
    }
    rightResult = !rightResult;
}
/*
function showResult(){
	clearInterval(timerRightPos);
	document.getElementById("board-page").style.display = "none";
	document.getElementById('titlebar').style.visibility = "hidden";
	document.getElementById("result-page").style.visibility = "visible";
	timer3 = setTimeout(onNextStep, 5000);
}
*/
function onNextStep() {

    /*	if(actionFile == 'game'){
            document.getElementById("board-page").style.display = "none";
            document.getElementById("result-page").style.visibility = "visible";
        }
    */
    switch (nextGame) {
        case 3:
        case '3':
        case '3.0':
            clearInterval(timer5);
            //		showFinalResult();
            if (typeof (nextPage) == 'undefined') {
                //online game
                showResult();
            } else if (nextPage.substr(0, "tutorialResult".length) == 'tutorialResult') {
                //tutorial
                window.location.href = nextPage
                    + (nextPage.indexOf("?") < 0 ? "?" : "&")
                    + "idx=" + params.idx;
            } else if (nextPage.substr(0, "execiseResult".length) == 'execiseResult') {
                //execise
                window.location.href = nextPage
                    + (nextPage.indexOf("?") < 0 ? "?" : "&")
                    + "opcount=" + opcount + "&ttime=" + totalTime + "&score=" + points;
            } else {
                //simulation
                window.location.href = nextPage;
            }
            break;
        case 2:
        case '2':
        case '2.0':
            if (actionFile == '') {
                var preInfo = '';
                var score = finishMsg.score;
                var displayInfo = '本局得分：' + score + '分';
                var einfo = (role == 'listener') ? finishMsg.examinfo : finishMsg.otherexaminfo;
                if (einfo != undefined && einfo.show != false) {
                    var p = 0;
                    if (einfo.star > currentStar) {
                        preInfo = '祝贺，您升星了！';
                        p = pointToNextStar + einfo.point;
                    } else {
                        p = pointToNextStar - einfo.total + einfo.point;
                    }
                    displayInfo = preInfo + '本局得分：' + score
                        + '分。获得积分：' + p;
                    updateStar(einfo.star, einfo.point, einfo.total);
                }
                JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"正在互换角色...\",\"msg\":\"' + displayInfo + '\",\"t\":\"3\"}');
            } else {
                //			alert("正在互换角色...");
                JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"\",\"msg\":\"正在互换角色...\",\"t\":\"3\"}');
            }
        case 1:
        case '1':
        case '1.0':
            if (typeof (nextPage) == 'undefined') {
                //online game;
                setTimeout('document.location.reload();', 1000);
            } else {
                //switch from listener to teller
                if (nextPage.substr(0, "index.html?tutorTeller".length) == 'index.html?tutorTeller') {
                    //tutorial
                    window.location.href = nextPage + "&star=" + params.star + "&pnt=" + params.pnt + "&ttl=" + params.ttl + "&idx=" + params.idx;
                } else {
                    window.location.href = nextPage;
                }
            }
            break;
    }
}

function showGameResult() {

    document.getElementById("subscore").innerHTML = (finishMsg.totalscore - finishMsg.score) + ' + ' + finishMsg.score;

    var score1 = "（无记录）";
    var score2 = "（无记录）";
    var users1 = "";
    var users2 = "";

    if (finishMsg.records[0] != undefined) {
        if (finishMsg.records[0].score >= 5000 && finishMsg.records[0].users != undefined) {
            score1 = finishMsg.records[0].score;
            users1 = finishMsg.records[0].users[0] + ' & ' + finishMsg.records[0].users[1];
        }
    }
    if (finishMsg.records[1] != undefined) {
        if (finishMsg.records[1].score >= 5000 && finishMsg.records[1].users != undefined) {
            score2 = finishMsg.records[1].score;
            users2 = finishMsg.records[1].users[0] + ' & ' + finishMsg.records[1].users[1];
        }
    }

    document.getElementById("recordA_score").innerHTML = '第1题：' + score1;
    document.getElementById("recordA_names").innerHTML = users1;
    document.getElementById("recordB_score").innerHTML = '第2题：' + score2;
    document.getElementById("recordB_names").innerHTML = users2;

    document.getElementById("exitButton").style.bottom = '10rem';
    //	document.getElementById("commentButton").style.bottom = '10rem';
}

function displayPoints() {
    points = points - currentMsg.timescore / 10;
    if (points <= 0) {
        clearInterval(timer1);
        points = 0;

        if (role == 'listener') {
            requestServer(apiCode, "Zero");
        }

        if (actionFile != '') {
            AE_timeout();
        }
    }

    //	textPoints.innerHTML = '得分 ' + points;
    //	document.getElementById("timepoints").innerHTML = countdownClock + " / " + points;
    //	document.getElementById("timepoints").innerHTML = "\u{1F552} " + countdownClock + " / \u{1F3F3} " + points;
    //	document.getElementById("timepoints").innerHTML = "\uD83D\uDD52 " + countdownClock + " / \uD83C\uDFF3 " + points;
    document.getElementById("timepoints").innerHTML = "\u23F1 " + countdownClock + " / \u2690 " + points;
}

function updateStar(star, point, total) {

    if (star != undefined && star != null && Number.isFinite(star)) {
        document.getElementById('starprogress').style.visibility = "visible";
        var stars = '';
        for (var i = 0; i < star; i++) {
            stars += '★';
        }
        document.getElementById("currentstar").innerHTML = stars;
    }

    if (point != undefined && point != null && total != undefined && total != null && total != 0) {
        document.getElementById("progress").style.width = 100 * point / total + '%';
    }
}

//initialization before receiving the GetInitInfo message
function initGame() {
    currentAction = 0;

    //game is triggered by server response of the initilization request, and online game always starts with countdown mode.
    if (actionFile == '') {
        startMode = 1;
        return;
    }

    //game starts immediately (countdown when startMode is 1)
    if (startMode < 2) {
        AE_init();
        AE_start();
        return;
    }

    //game is triggered by a user click (must be, if playing voice is required) 
    if (startMode == 2) {
        AE_init();
        document.getElementById("countdown").style.visibility = 'hidden';
        document.getElementById("tutorialprompt").style.display = 'block';
        document.getElementById("countdownprompt").innerHTML = '请点击屏幕开始';
        document.getElementById("tutorialprompt").innerHTML = introText;
        return;
    }
}

function touchToGo() {
    if (actionFile != '') {
        AE_start();
    }
}

function onGameNativeMsg(source, msg) {

    //	var msg = eval("(" + jMsg + ")");

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetInitInfo':
                    onCountdown(msg.info);
                    break;
                case 'Move':
                case 'Zero':
                case 'ChgBG':
                    onFinish(msg.request, msg.info);
                    //			updateStar(msg.info);
                    break;
                case 'Look':
                    onLookDone(msg.info.shapes);
					points = msg.info.score;
                    break;
                case 'Report':
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"服务器已收到举报\",\"t\":\"3\"}');
                    break;
                    break;
            }

        case 'peer':
            switch (msg.type) {
                case 'move':
                    onMove(msg);
                    break;
                case 'chgBG':
                    onChgBkg(msg);
                    break;
                //		case 'correctBkg':
                //			onCorrectBkg();
                //			break;
                case 'finish':
                    onFinish('', msg);
                    break;
                case 'inplaceAck':
                    clearTimeout(timer2);
                    break;
                case 'syncpoint':
                    points = msg.points;
                    break;
                case 'look':
					onPeerLook();
                    break;
            }
            break;

        case 'system':
            switch (msg.code) {
                case 200:
                case '200':
                case '200.0':
                case 208:
                case '208':
                case '208.0':
                    timer4 = setTimeout("JavaScriptInterface.nativeCommand('micOn', '')", 2000);
                    if (isSimulation) {
                        console.log("micOn");
                    }
                    break;
                case 222:
				case '222':
				case '222.0':
					if(dialogType == DIA_LOOK){
						dialogType = null;
						requestServer(apiCode, "Look");
					}
					dialogType = null;

             }
   }
}

